/*******************************

	Test application for TextOnPath library.
	
	
	
	Yeah, yeah, one big ugly routine. But hey,
	it's a test app.  The library code is much
	nicer!

*********************************/


#define DEBUGLEVEL 4

#include "Math.h"
#include "StdIo.h"
#include "Events.h"
#include "Windows.h"
#include "Fonts.h"
#include "QuickDraw.h"
#include "Windows.h"
#include "Scrap.h"

#include "GXTypes.h"
#include "GXMath.h"
#include "GXFonts.h"
#include "GXGraphics.h"
#include "GXLayout.h"
#include "GXPrinting.h"
#include "GXExceptions.h"
#include "GXEnvironment.h"
#include "GraphicsLibraries.h"
#include "DecompressShape.h"

#include "CurveLayout.h"


//#define FLICKERFREE



enum {
	kNullCharCode				= 0,
	kHomeCharCode				= 1,
	kEnterCharCode				= 3,
	kEndCharCode				= 4,
	kHelpCharCode				= 5,
	kBellCharCode				= 7,
	kBackspaceCharCode			= 8,
	kTabCharCode				= 9,
	kLineFeedCharCode			= 10,
	kVerticalTabCharCode		= 11,
	kPageUpCharCode				= 11,
	kFormFeedCharCode			= 12,
	kPageDownCharCode			= 12,
	kReturnCharCode				= 13,
	kFunctionKeyCharCode		= 16,
	kEscapeCharCode				= 27,
	kClearCharCode				= 27,
	kLeftArrowCharCode			= 28,
	kRightArrowCharCode			= 29,
	kUpArrowCharCode			= 30,
	kDownArrowCharCode			= 31,
	kDeleteCharCode				= 127,
	kNonBreakingSpaceCharCode	= 202
};


/* globals */

MenuHandle			hAppleMenu;
MenuHandle			hHighlightMenu;
MenuHandle			hTranformMenu;
MenuHandle			hFileMenu;
MenuHandle			hEditMenu;

gxJob						theJob = nil;

Boolean flickerFree = false;
Boolean brokenHighlight = false;



void DoAboutBox();
void DoAboutBox()
	{
		WindowRef		theWindow;
		Rect				winRect = {100, 100, 300, 400};
		gxViewPort	winPort;
		gxShape			thePath;
		gxShape			textShape;
		gxShape			aboutShape;
		gxShape			highlight = nil;
		gxFont			theFont;
		long				charIndex;		
		static gxCurve	curveGeometry = {ff(50), ff(175), ff(150), ff(-115), ff(250), ff(175) };
		long				tix;
		Boolean			erase;
		long				charCount;
		EventRecord	theEvent;				
		
		
		theWindow = NewCWindow(nil, &winRect, "\pAbout Curvelayout", true, dBoxProc, nil, false, nil);
		SelectWindow(theWindow);
		winPort =  GXNewWindowViewPort((WindowPtr)theWindow);

		thePath = GXNewCurve(&curveGeometry);
		textShape = GXNewText(58, "GX Curve Layout,  Apple Computer Inc. 1996, Daniel Lipton", nil); charCount = 58;
		GXSetShapeTextSize(textShape, ff(14));
		
		GXFindFonts(0, gxFullFontName, gxNoPlatform, gxNoScript, gxNoLanguage, 12, (unsigned char*)"Skia Regular", 1, 1, &theFont);
		GXSetShapeFont(textShape, theFont);
		GXSetShapeType(textShape, gxLayoutType);
		
		GXSetShapeType(thePath, gxPathType);
		aboutShape = ClNewCurveLayout(textShape, thePath, false);
		GXSetShapeViewPorts(aboutShape, 1, &winPort);
		GXSetShapeViewPorts(thePath, 1, &winPort);
		GXDrawShape(aboutShape);

		charIndex = 1;
		erase = false;
		tix = TickCount();
		do  {
		
			if (TickCount() > (tix + 3)) {			// do it every 3 ticks
				
				tix = TickCount();
				
				if (highlight != nil)
					GXDrawShape(highlight);
									
				highlight = ClGetCurveLayoutHighlight(aboutShape, 0, charIndex, gxHighlightAverageAngle, highlight);
				SetShapeCommonTransfer(highlight, gxHighlightMode);
				SetShapeCommonColor(highlight, gxWhite);
				GXDrawShape(highlight);
				charIndex += 3;
				if (charIndex > charCount) {
				
					gxShape			eraser = GXNewShape(gxFullType);
					GXSetShapeViewPorts(eraser, 1, &winPort);
					SetShapeCommonColor(eraser, gxWhite);
					GXDrawShape(eraser);
					GXDisposeShape(eraser);
					charIndex = 1;
					GXRotateShape(aboutShape, ff(15), ff(100), ff(100));
					GXDrawShape(aboutShape);
					GXDisposeShape(highlight);
					highlight = nil;
					
				}//end if
					
			}//end if	
		
			if (WaitNextEvent(everyEvent, &theEvent, 0, nil))
				if (theEvent.what == mouseDown)
					break;
						
		} while (true);
		
		ClDisposeCurveLayout(aboutShape);
		GXDisposeShape(textShape);
		GXDisposeShape(thePath);
		DisposeWindow(theWindow);
		if (highlight != nil)
			GXDisposeShape(highlight);
		
	
	}//DoAboutBox

/* Procedure to make a nice path for us to draw on */
gxShape MakeThePath(void);
gxShape MakeThePath(void)
	{
		static 				gxCurve			curveGeometry = {ff(50), ff(325), ff(175), ff(150), ff(300), ff(325) };
		static 				gxCurve			curveGeometry2 = {ff(300), ff(325), ff(425), ff(500), ff(550), ff(325) };
		gxShape				nicePath;
		gxShape				curve2;
	
		nicePath = GXNewCurve(&curveGeometry);
		GXSetShapeType(nicePath, gxPathType);
		curve2= GXNewCurve(&curveGeometry2);
		GXSetShapeParts(nicePath, 0, 0, curve2, gxBreakNeitherEdit);
		GXDisposeShape(curve2);
		
		GXSetShapeFill(nicePath, gxFrameFill);
		
		GXMoveShape(nicePath, ff(0), ff(-120));
	
		return(nicePath);	
	}

/** Procedure sets up the menus **/  
void SetupMenus();
void SetupMenus()
  {
    Handle HMenuBar;
	
		HMenuBar = GetNewMBar(128);		//Get the menu bar resource.
		SetMenuBar(HMenuBar);					//Make it the menu bar.
		DrawMenuBar();								//Draw the thing.

		DisposHandle(HMenuBar);				//Don't need the handle any more.

		AddResMenu(GetMHandle(1000),'DRVR');  /* add DA's to apple menu */
		
		hAppleMenu = GetMHandle(1000);  				/* get handles for each menu */
		hFileMenu = GetMHandle(10001);
		hEditMenu	= GetMHandle(1002);
		hTranformMenu = GetMHandle(1003);
		hHighlightMenu = GetMHandle(1004);
		
		CheckItem(hHighlightMenu, 1, flickerFree);
		CheckItem(hHighlightMenu, 2, brokenHighlight);
								
  } //end SetupMenus



void DoPageSetup();
void DoPageSetup()
	{
		OSErr			status;
		
		if (theJob == nil) {
			status = GXNewJob(&theJob);	
			nrequire(status, failed_newjob);
		}//end if

		GXJobDefaultFormatDialog(theJob, nil);
		
failed_newjob:
		;
		
	}//DoPageSetup

void PrintTheShapes(gxShape curveShape, gxShape curveLayout, gxShape highlight, Boolean doDialog);
void PrintTheShapes(gxShape curveShape, gxShape curveLayout, gxShape highlight, Boolean doDialog)
	{
		OSErr						status = noErr;
		gxViewPort			thePort;
		gxDialogResult	result = gxOKSelected;
			
		if (GXGetShapeViewPorts(curveLayout, &thePort) > 1)
			DebugStr("\p you might crash now");

		if (theJob == nil) {
			status = GXNewJob(&theJob);	
			nrequire(status, failed_newjob);
		}//end if
		
		if (doDialog)
			result = GXJobPrintDialog(theJob, nil);
		
		if (result == gxOKSelected) {
		
			GXStartJob(theJob, "\pCurveLayout", 1);
			GXStartPage(theJob, 1, nil, 1, &thePort);
			
			GXDrawShape(curveShape);
			GXDrawShape(curveLayout);
			if (highlight != nil)
				GXDrawShape(highlight);
				
			GXFinishPage(theJob);
			GXFinishJob(theJob);
		
		}//end if
		
		status = GXGetJobError(theJob);
		if (status != noErr)
			DebugStr("\pA Printing Error happend.");	
		
failed_newjob:
		;
			
	}//PrintTheShapes;


/***********************

	Routine to put a picture
	full of the content into 
	the clipboard. 
	
************************/
void PutShapesInScrap(gxShape curveShape, gxShape textOnCurve, gxShape highlight);
void PutShapesInScrap(gxShape curveShape, gxShape textOnCurve, gxShape highlight)
	{
			gxShape			thePicture = GXNewShape(gxPictureType);
	
	
			GXSetPictureParts(thePicture, 1, 0, 1, &curveShape, nil, nil, nil);
			GXSetPictureParts(thePicture, 1, 0, 1, &textOnCurve, nil, nil, nil);
			
			if (highlight != nil)
				GXSetPictureParts(thePicture, 1, 0, 1, &highlight, nil, nil, nil);
				
			ShapeToScrap(thePicture, false, false, false);
		
			GXDisposeShape(thePicture);
	
	}//PutShapesInScrap


/****************************

	Routine: 	GetCurveAndLayoutFromPicture
	
	This routine finds the first path shape or polygon
	and layout shape in a picture and returns them.
	
	Will traverse the picture recursively until the whole picture
	has been done or it has found both.

*****************************/
void GetCurveAndLayoutFromPicture(gxShape theShape, gxShape *thePath, gxShape *theLayout);
void GetCurveAndLayoutFromPicture(gxShape theShape, gxShape *thePath, gxShape *theLayout)
	{
		long 					nShapes;
		gxShapeType 	theType;
		long					idx;
		gxShape				child;
		
		theType = GXGetShapeType(theShape);
		
		if (theType == gxLayoutType) {
			
			if (*theLayout == nil)
				*theLayout = theShape;
		
		} else if ( (theType == gxPathType) || (theType == gxPolygonType) ) {
		
			*thePath = theShape;
		
		} else if (theType == gxPictureType) {
		
			/* If we haven't found both of them yet, continue traversing recursively */
			
			if ( (*thePath == nil) || (*theLayout == nil) ) {

				nShapes =  GXGetPictureParts(theShape, 1, gxSelectToEnd, nil, nil, nil, nil);

				for (idx = 1; idx <= nShapes; ++idx ) {

					GXGetPictureParts(theShape, idx, 1, &child, nil, nil, nil);
					GetCurveAndLayoutFromPicture(child, thePath, theLayout);				// recursion, ick!

				}//end for

			}//end if
					
		}//end if
	
	}//GetCurveAndLayoutFromPicture

/***********************

	Routine: GetShapesFromScrap
	
	This routine allows a user
	to paste in a new curve and layout to be used.
	
************************/
void GetShapesFromScrap(gxShape curveLayout);
void GetShapesFromScrap(gxShape curveLayout)
	{
		PicHandle			hScrap;
		gxShape				scrapShape;
		long					pasteSize;
		long					offset;
		Rect					theRect;
		Point					styleStretch = {1,1};
		gxShapeType		theType;
		OSErr					status;
		gxShape				newPath = nil;
		gxShape				newLayout = nil;
		gxShape				theText, thePath;
		gxTransform		theTransform;
					
		hScrap = (PicHandle)NewHandle(0);
		nrequire(status = MemError(), failed_allocate);									
		pasteSize = GetScrap((Handle)hScrap, 'PICT', &offset); 

		if (pasteSize > 0) {

			BlockMove(&(*hScrap)->picFrame, &theRect, sizeof(Rect));
					
			scrapShape = GXConvertPICTToShape(hScrap, gxSimpleGeometryTranslation | gxLayoutTextTranslation, &theRect, &theRect, styleStretch, nil, nil);

			theType = GXGetShapeType(scrapShape);
						
			GetCurveAndLayoutFromPicture(scrapShape, &newPath, &newLayout);
			
			ClGetCurveLayout(curveLayout, &theText, &thePath);
			
			if (newPath) {

				theTransform = GXGetShapeTransform(thePath);
				GXSetShapeTransform(newPath, theTransform);
				thePath = GXCopyToShape(thePath, newPath);
				GXSetShapeAttributes(thePath, GXGetShapeAttributes(thePath) | gxMapTransformShape);
				
			}//end if
				
			if (newLayout) {
			
				theTransform = GXGetShapeTransform(theText);
				GXSetShapeTransform(newLayout, theTransform);
				theText = GXCopyToShape(theText, newLayout);
				GXSetShapeAttributes(theText, GXGetShapeAttributes(theText) | gxNoMetricsGridShape);
				
			}//end if
			
			ClChangedCurveLayout(curveLayout);
	
			GXDisposeShape(scrapShape);
					
		}//end if
		
		
		DisposeHandle((Handle)hScrap);

failed_allocate:
		;		
	
	}//GetShapesFromScrap


/** Handle menu selection **/
Boolean HandleMenu(long menuInfo, gxShape textOnCurve, gxShape curveShape, gxShape highlight, gxShape caret, Boolean *changed);
Boolean HandleMenu(long menuInfo, gxShape textOnCurve, gxShape curveShape, gxShape highlight, gxShape caret, Boolean *changed)
	/** menuInfo is the value that the OS returns when menu event is handled. **/
	{
		short whichMenu,				//Which menu was chosen.
				  whichItem,				//Which item was chosen.
				  DARefnum;					//Used to open a DA.
		Str255 itemName;				//Used to get the name of a DA.
		Boolean	quit = false;
		
		*changed = false;
				
		whichMenu = HiWord(menuInfo);		//Get the menu information.
		whichItem = LoWord(menuInfo);
		
		switch(whichMenu) {
		
			case 1000:		/* apple menu */
				switch(whichItem) {
					case 1:
						DoAboutBox();
						break;
						
					default:
						break;
					
				}//end switch
				break;
				
			case 1001:		/* file menu */
				switch(whichItem) {
					
					case 1:
						DoPageSetup();
						break;

					case 2:
						PrintTheShapes(curveShape, textOnCurve, highlight, true);
						break;
						
					case 3:
						PrintTheShapes(curveShape, textOnCurve, highlight, false);
						break;
						
					case 5:
						quit = true;
						break;				
				}
				break;
				
			case 1002:		/* edit menu */
				switch(whichItem) {
				
					case 1:
						PutShapesInScrap(curveShape, textOnCurve, highlight);
						break;

					case 2:
						GetShapesFromScrap(textOnCurve);
						*changed = true;
						break;
												
				}
				break;
				
				
			case 1003:		/* Transform menu */
				switch(whichItem) {
				
					gxPoint		center;
				
					case 1:			/* rotate */
						GXGetShapeCenter(curveShape, 0, &center);
						GXRotateShape((textOnCurve), ff(-10), center.x, center.y);
						GXRotateShape((curveShape), ff(-10), center.x, center.y);
						break;
						
					case 2:			/* skew */
						GXSkewShape((textOnCurve), fixed1/8, 0, 0, 0);
						GXSkewShape((curveShape), fixed1/8, 0, 0, 0);
						break;
						
					case 3:			/* Perspect */
						{
							gxMapping		aMapping;
							ResetMapping(&aMapping);
							
							aMapping.map[0][2] = fract1/2048;
							aMapping.map[1][1] = ff(5) / 4;
							
							GXMapShape((textOnCurve), &aMapping);
							GXMapShape((curveShape), &aMapping);
							
						}
						break;
						
					case 4:				/* seperator line */
						break;
						
					case 5:				/* Reset transform */
						{
							gxMapping		aMapping;
							ResetMapping(&aMapping);
														
							GXSetShapeMapping((textOnCurve), &aMapping);
							GXSetShapeMapping((curveShape), &aMapping);
							
						}
						break;
				
				}//end switch
				
				*changed = true;
				
				/* make sure caret and highlight get the new transform the text and path got */
				if (caret)
					GXSetShapeTransform(caret, GXGetShapeTransform(textOnCurve));
				if (highlight)
					GXSetShapeTransform(highlight, GXGetShapeTransform(textOnCurve));
				
				break;
				
			case 1004:			/* curve layout options menu */
				switch(whichItem) {
				
					case 1:				/* flicker free highlight */
						flickerFree = !flickerFree;
						CheckItem(hHighlightMenu, whichItem, flickerFree);
						break;
						
					case 2:				/* Illustrator style highlight */
						brokenHighlight = !brokenHighlight;
						CheckItem(hHighlightMenu, whichItem, brokenHighlight);
						if (brokenHighlight)
							ClSetCurveLayoutFlags(textOnCurve, clNonContiguousHighlight);
						else
							ClSetCurveLayoutFlags(textOnCurve, clNoFlags);

						break;				
				
				}//end switch
				break;
		
		}//end switch
		
		HiliteMenu(0);  /* clear the menu bar */
		
		return(quit);
		
	} /* end HandleMenu */


	
main() {
		
	gxPoint					position;
	gxShape					textShape, textOnCurve;
	gxShape					curveShape;
	gxShape					comparisonDraw;
	gxShape					highlight = nil;
	gxFont					theFont;
	
	static gxRectangle	endPoint = {ff(545), ff(320), ff(555), ff(330)};
	
	
	WindowRef				theWindow;
	Rect						winRect = {50, 5, 450, 600};
	gxViewPort			winPort;
	
	long						charCount;
	curveLayoutFlags	clFlags = 0;
	gxShape					tooBigShape = nil;
	Boolean					drewTooBig = false;
	RgnHandle				grayRgn;
	Rect						DragArea;
	
  InitGraf(&qd.thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	TEInit();
	InitDialogs(nil);

	
	InitCommonColors();
		

	SetupMenus();
	
	theWindow = NewCWindow(nil, &winRect, "\pCurve Layout", true, kStandardWindowDefinition, nil, false, nil);
	SetPort((GrafPtr) theWindow);

	grayRgn = GetGrayRgn();
	DragArea = (*grayRgn)->rgnBBox;

		
	GXEnterGraphics();
	GXInitPrinting();
	
	GXValidateAll();
	SetGraphicsLibraryErrors();	/* set the error and warning routines */

	winPort =  GXNewWindowViewPort((WindowPtr)theWindow);
	SetDefaultViewPort(winPort);

	position.x = ff(0);
	position.y = ff(0);
	
	curveShape = MakeThePath();
	
	tooBigShape = GXNewRectangle(&endPoint);
	GXSetShapePen(tooBigShape, ff(5));
	SetShapeCommonTransfer(tooBigShape, gxHighlightMode);
	SetShapeCommonColor(tooBigShape, gxWhite);
	

	textShape = GXNewText(15, "You can edit me", nil);
	GXSetShapeTextSize(textShape, ff(36));
	
	#if TESTVERTICAL
		GXSetShapeTextAttributes(textShape, GXGetShapeTextAttributes(textShape) | gxVerticalText);
	#endif
		
	GXFindFonts(0, gxFullFontName, gxNoPlatform, gxNoScript, gxNoLanguage, 14, (unsigned char*)"Apple Chancery", 1, 1, &theFont);
	GXSetShapeFont(textShape, theFont);
	GXSetShapeType(textShape, gxLayoutType);

	charCount = GXGetLayout(textShape, nil, nil, nil, nil, nil, nil, nil, nil, nil);
		
	GXSetShapeAttributes(curveShape, GXGetShapeAttributes(curveShape) | gxMapTransformShape);
	textOnCurve = ClNewCurveLayout(textShape, curveShape, true);
	
	/* Make a picture that contains a clone of the layout for comparison drawing */
	{
		comparisonDraw = GXNewShape(gxPictureType);
		GXSetPictureParts(comparisonDraw, 0, 0, 1, &textShape, nil, nil, nil);
		GXMoveShape(comparisonDraw, ff(10), ff(385));	
	}

	GXDrawShape(curveShape);
	GXDrawShape(textOnCurve);

	
	{
		EventRecord			theEvent;
		Boolean					quit = false;
		gxPoint					mousePoint, newPoint;
		Point						mouse;
		gxLayoutHitInfo	hitInfo;
		gxByteOffset		offset1, caretOffset, offset2, o1, o2;
		gxShape					diffHighlight = nil, oldHighlight = nil;
		gxShape					caretShape = nil;
		Boolean					haveCaret = false;
		Boolean					caretBlink = false;				// true = Drawn.
		long						lastTix = TickCount();
		char						key;
		short						windowLoc;
		WindowRef				whichWindow;
		Boolean					changedShape = false;
		Boolean					update;
					
		while(!quit) {
		
			/* Blink the cursor */
			if (haveCaret && (caretShape != nil) ) {

				if ( TickCount() > (lastTix + 15) ) {
					
					lastTix = TickCount();
					GXDrawShape(caretShape);
					caretBlink = !caretBlink;
				
				}//end if
			
			}//end if

			/* redraw if shape is changed */
			if (changedShape) {
			
				gxShape eraser = GXNewShape(gxFullType);
				SetShapeCommonColor(eraser, gxWhite);
				
				if (update)
					BeginUpdate(theWindow);

				GXDrawShape(eraser);
				GXDisposeShape(eraser);
				GXDrawShape(curveShape);
				GXDrawShape(textOnCurve);

				if (highlight != nil)
					GXDrawShape(highlight);
				
				if (haveCaret) {
					GXDrawShape(caretShape);
					caretBlink = true;
				}//endif

				if (update)					
					EndUpdate(theWindow);
				
				update = false;
				changedShape = false;
			
				charCount = GXGetLayout(textShape, nil, nil, nil, nil, nil, nil, nil, nil, nil);

			}//end if

			if ( WaitNextEvent(everyEvent, &theEvent, 0, nil) ) {
				
				update = false;
				
				switch(theEvent.what) {
				
					case updateEvt:
						if ( (WindowPtr)(theEvent.message) == theWindow ) {
						
							/* mark shape changed to force redraw */
							changedShape = true;
							update = true;

						}//endif
						
						break;
				
					case keyDown:
						if (theEvent.modifiers & cmdKey) {
						
							long menuthing = MenuKey( (short)(theEvent.message & charCodeMask) );
							quit = HandleMenu( menuthing,textOnCurve, curveShape, highlight, caretShape, &changedShape  );
							break;
							
						}//end if
					case autoKey:
						key = (unsigned char)(theEvent.message & charCodeMask);
						switch (key) {
															
							case kLeftArrowCharCode:
							case kRightArrowCharCode:

								if (key == kLeftArrowCharCode)
									--caretOffset;
								else
									++caretOffset;
								
								if (caretOffset < 0)
									caretOffset = 0;
								else if (caretOffset > charCount)
									caretOffset = charCount;
																	
								if (haveCaret && (caretShape != nil) ) {
								
									if (caretBlink)
										GXDrawShape(caretShape);	// erase current caret if it was drawn;
									
									caretShape = ClGetCurveLayoutCaret(textOnCurve, caretOffset, gxHighlightAverageAngle, gxSplitCaretType, caretShape);
									SetShapeCommonTransfer(caretShape, gxHighlightMode);
									SetShapeCommonColor(caretShape, gxWhite);
									GXDrawShape(caretShape);
									caretBlink = true;

								}//end if									
								
								break;
								
							case kBackspaceCharCode:
								if (highlight != nil ) {

									GXDrawShape(highlight);
									GXDisposeShape(highlight);	
									highlight = nil;
									if (diffHighlight != nil) {
										GXDisposeShape(diffHighlight);
										diffHighlight = nil;
									}//end if
									
									if (oldHighlight != nil) {
										GXDisposeShape(oldHighlight);
										oldHighlight = nil;
									}//end if
									
									
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxWhite);
									GXDrawShape(textOnCurve);
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxBlack);
									
									GXSetLayoutParts(textShape, offset1, offset2, 0, nil, nil, 0, nil, nil, 0, nil, nil);
									ClChangedCurveLayout(textOnCurve);
									clFlags = ClGetCurveLayout(textOnCurve, nil, nil);
									GXDrawShape(curveShape);
									GXDrawShape(textOnCurve);
									
									charCount = GXGetLayout(textShape, nil, nil, nil, nil, nil, nil, nil, nil, nil);
																										
									caretOffset = offset1;
									caretShape = ClGetCurveLayoutCaret(textOnCurve, caretOffset, gxHighlightAverageAngle, gxSplitCaretType, caretShape);
									SetShapeCommonTransfer(caretShape, gxHighlightMode);
									SetShapeCommonColor(caretShape, gxWhite);
									GXDrawShape(caretShape);
									caretBlink = true;
									haveCaret = true;
									
								} else if (haveCaret && (caretOffset > 0) ) {
								
									if (caretBlink)
										GXDrawShape(caretShape);	// erase current caret if it was drawn;										
									
									/* delete a character */
										
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxWhite);
									GXDrawShape(textOnCurve);
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxBlack);

									caretOffset -= 1;
									GXSetLayoutParts(textShape, caretOffset, caretOffset+1, 0, nil, nil, 0, nil, nil, 0, nil, nil);
									ClChangedCurveLayout(textOnCurve);
									clFlags = ClGetCurveLayout(textOnCurve, nil, nil);
									GXDrawShape(curveShape);
									GXDrawShape(textOnCurve);

									caretShape = ClGetCurveLayoutCaret(textOnCurve, caretOffset, gxHighlightAverageAngle, gxSplitCaretType, caretShape);
									SetShapeCommonTransfer(caretShape, gxHighlightMode);
									SetShapeCommonColor(caretShape, gxWhite);
									
									GXDrawShape(textOnCurve);
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxBlack);
									
									GXDrawShape(caretShape);
									caretBlink = true;
									
									charCount -= 1;
								
								}//end if
								break;
								
							default:
								/* Insert the keystroke into the layout */
								if (highlight != nil ) {
								
									/* If there was a selection, Delete it and mae a caret */

									GXDrawShape(highlight);
									GXDisposeShape(highlight);	
									highlight = nil;
									if (diffHighlight != nil) {
										GXDisposeShape(diffHighlight);
										diffHighlight = nil;
									}//end if
									
									if (oldHighlight != nil) {
										GXDisposeShape(oldHighlight);
										oldHighlight = nil;
									}//end if
									
									
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxWhite);
									GXDrawShape(textOnCurve);
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxBlack);

									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxWhite);
									GXDrawShape(comparisonDraw);
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxBlack);
									
									GXSetLayoutParts(textShape, offset1, offset2, 0, nil, nil, 0, nil, nil, 0, nil, nil);
									ClChangedCurveLayout(textOnCurve);
									clFlags = ClGetCurveLayout(textOnCurve, nil, nil);
									GXDrawShape(curveShape);
									GXDrawShape(textOnCurve);
									
									GXDrawShape(comparisonDraw);
									
									charCount = GXGetLayout(textShape, nil, nil, nil, nil, nil, nil, nil, nil, nil);
									
									caretOffset = offset1;
									caretShape = ClGetCurveLayoutCaret(textOnCurve, caretOffset, gxHighlightAverageAngle, gxSplitCaretType, caretShape);
									SetShapeCommonTransfer(caretShape, gxHighlightMode);
									SetShapeCommonColor(caretShape, gxWhite);
									GXDrawShape(caretShape);
									caretBlink = true;
									haveCaret = true;
																
								}//end if
								
								/* Now insert the keystroke into the layout */
								{
									short		one = 1;
									char		text;
									char		*textPtr = &text;

									/* Erase the caret if we have one */
									if (caretBlink && haveCaret) {
										GXDrawShape(caretShape);
										caretBlink = false;
									}//end if

									/* erase whole shape */
									
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxWhite);
									GXDrawShape(textOnCurve);
									SetShapeCommonColor(ClGetShapeForInk(textOnCurve), gxBlack);

									SetShapeCommonColor(textShape, gxWhite);
									GXDrawShape(comparisonDraw);
									SetShapeCommonColor(textShape, gxBlack);

									text = (char)key;
									GXSetLayoutParts(textShape, caretOffset, caretOffset, 1, &one, (void*)&textPtr, 0, nil, nil, 0, nil, nil);
									ClChangedCurveLayout(textOnCurve);
									clFlags = ClGetCurveLayout(textOnCurve, nil, nil);
									GXDrawShape(textOnCurve);
									GXDrawShape(comparisonDraw);
									charCount += 1;
									caretOffset += 1;
									caretShape = ClGetCurveLayoutCaret(textOnCurve, caretOffset, gxHighlightAverageAngle, gxSplitCaretType, caretShape);
									SetShapeCommonTransfer(caretShape, gxHighlightMode);
									SetShapeCommonColor(caretShape, gxWhite);
								}
								break;
						
						}//end switch

						break;
						
					case mouseDown:
						mouse = theEvent.where;
						windowLoc = FindWindow(mouse, &whichWindow);
						if ((windowLoc == inDrag) && (whichWindow == theWindow) ) {
						
							DragWindow(whichWindow, mouse, &DragArea);
							
						} else if (windowLoc == inMenuBar) {

							quit = HandleMenu(MenuSelect(mouse), textOnCurve, curveShape, highlight, caretShape, &changedShape);
														
						} else if ( whichWindow == theWindow ) {
						
							GXGetViewPortMouse(winPort, &mousePoint);
							offset1 = ClHitTestCurveLayout(textOnCurve, &mousePoint, gxHighlightAverageAngle, &hitInfo, nil);
							offset2 = offset1;

							/* Erase old higlight on a click and reset highlight shapes */
							
							if ( highlight != nil) {
								GXDrawShape(highlight);
								GXDisposeShape(highlight);
								highlight = nil;
							}//end if
							
							if (diffHighlight != nil) {
								GXDisposeShape(diffHighlight);
								diffHighlight = nil;
							}//end if
							
							if (oldHighlight != nil) {
								GXDisposeShape(oldHighlight);
								oldHighlight = nil;
							}//end if
							
							/* erase the caret shape */
							if (caretBlink && haveCaret && (caretShape != nil) )
								GXDrawShape(caretShape);

							haveCaret = true;

							/* Track the mouse */
														
							while(Button()) {
							
								GXGetViewPortMouse(winPort, &newPoint);
								if ( (mousePoint.x != newPoint.x) || (mousePoint.y != newPoint.y)) {

									mousePoint.x = newPoint.x; mousePoint.y = newPoint.y;
									o2 = ClHitTestCurveLayout(textOnCurve, &mousePoint, gxHighlightAverageAngle, &hitInfo, nil);
									
									if (o2 != offset2) {
									
										offset2 = o2;
										
										if ( offset1 < offset2 ) {
											o1 = offset1;
											o2 = offset2;
										 } else {
										 	o1 = offset2;
										 	o2 = offset1;
										 }//end if
										 
										if (o1 != o2) {
											
											/* If there is a selection range */

											if (flickerFree) {
											
												if (highlight != nil)
													oldHighlight = GXCopyToShape(oldHighlight, highlight);
													
											} else {
											
												if (highlight != nil)
													GXDrawShape(highlight);
													
											}//end if
												
											highlight = ClGetCurveLayoutHighlight(textOnCurve, o1, o2, gxHighlightAverageAngle, highlight);
											
											SetShapeCommonTransfer(highlight, gxHighlightMode);
											SetShapeCommonColor(highlight, gxWhite);
											
											if (flickerFree) {

												diffHighlight = GXCopyToShape(diffHighlight, highlight);
												if (oldHighlight != nil)
													GXExcludeShape(diffHighlight, oldHighlight);
												
												GXDrawShape(diffHighlight);

											} else {

												GXDrawShape(highlight);

											}//end if
											
											haveCaret = false;
																														
										}//end if
										
									}//end if
									
								}//end if
																									
							}//end while
							
							if (offset2 < offset1) {
								gxByteOffset temp = offset2;
								offset2 = offset1;
								offset1 = temp;
							}//end if
							
							if (haveCaret) {
							
								caretOffset = offset1;
								caretShape = ClGetCurveLayoutCaret(textOnCurve, caretOffset, gxHighlightAverageAngle, gxSplitCaretType, caretShape);
								SetShapeCommonTransfer(caretShape, gxHighlightMode);
								SetShapeCommonColor(caretShape, gxWhite);
								GXDrawShape(caretShape);
								caretBlink = true;
															
							}//end if	
														
						}//end if
												
						break;
						
					default:
						break;
				
				}//end switch

			}//end if
			
			/* Draw the indicator of layout being too big for path if necessary */
			
			if ( clFlags & clTextTooBigForPath ) {
			
				if (!drewTooBig ) {
					SysBeep(10);
					GXDrawShape(tooBigShape);
					drewTooBig = true;
				}//end if
														
			} else {
			
				if (drewTooBig) {
					SysBeep(10);
					GXDrawShape(tooBigShape);			//erase it.
					drewTooBig = false;
					
				}//end if
			
			}//end if
					
		}//end while
		
		/* clean up after ourselves */
		
		if (highlight != nil)
			GXDisposeShape(highlight);
		if (diffHighlight != nil)
			GXDisposeShape(diffHighlight);
		if (oldHighlight != nil)
			GXDisposeShape(oldHighlight);
		if (caretShape != nil)
			GXDisposeShape(caretShape);
	}

	ClDisposeCurveLayout(textOnCurve);
	GXDisposeShape(curveShape);
	GXDisposeShape(textShape);
	GXDisposeShape(tooBigShape);
	GXDisposeShape(comparisonDraw);
	
	if (theJob != nil)
		GXDisposeJob(theJob);


	
	GXExitPrinting();		
	GXExitGraphics();

	DisposeWindow(theWindow);
	
}

