// IconEdit.r 
// Copyright  1988-96 by Apple Computer, Inc. All rights reserved. 

/* ==============================   Includes   ================================= */

#ifndef __AEREGISTRY.R__
#include "AERegistry.r"
#endif

#ifndef __AEUSERTERMTYPES__
#include "AEUserTermTypes.r"
#endif

#ifndef __APPLEEVENTS_R__
#include "AppleEvents.r"
#endif

#ifndef __TYPES_R__
#include "Types.r"
#endif

#ifndef __SYSTYPES_R__
#include "SysTypes.r"
#endif

#ifndef __MACAPPVERSION__
#include "MacAppVersion.h"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#ifndef THINK_Rez
#if qDebug | qPerform
include "Debug.rsrc" not 'ckid';
include "Dialog.rsrc" not 'ckid';
#endif

/* include scripting resources */
include "MacApp.rsrc" not 'ckid';
include "Printing.rsrc" not 'ckid';

#ifndef MW_Rez 
#if !qNoCode
include $$Shell("ObjApp")$$Shell("XAppName") 'CODE';
#if qModelCFM
include $$Shell("ObjApp")$$Shell("XAppName") 'cfrg';
include $$Shell("ObjApp")$$Shell("XAppName") 'rseg';
#endif
#endif
#endif // !MW_Rez
#endif // !THINK_Rez

/* ==============================   Constants   ================================ */

#define cZoomIn				1000
#define cZoomOut			1001
#define cInvert				1002
#define cDrawCommand		1003
#define cSetColor			1005

#define kSeedIconId			1000
#define kIconWindowId		1000
#define kIconEditViewId		1001
#define kPencilCursorId		1000

#define kIconViewHeight		32 * 7 + 10	 /* 7 times actual size, 5 pixel borders */
#define kIconViewWidth		32 * 7 + 10	 /* 7 times actual size, 5 pixel borders */

#define kIconWindowHeight	kIconViewHeight + kSBarSizeMinus1
#define kIconWindowWidth	kIconViewWidth + kSBarSizeMinus1

#define kIconEditApp		1000

#define mIcon				4

#define kAEIconEditDispatchTable	1000	/* ID of the 'aedt' resource for IconEdit custom events */


/* =====================   The overall package version   ====================== */

include "Defaults.rsrc"  'vers' (2);		// Overall package

/* =================   The revision of this particular file   ================= */
RESOURCE 'vers' (1,
#if qNames
"File Version",
#endif
	purgeable) {
	MA_VERS_CODE,
	verUs,
	MA_SHORT_VERSION,
	"IconEdit"
	MA_SHORT_VERSION
	",  1988-95 Apple Computer, Inc."
};

/*--------------------------------------------------------------------------------
 MultiFinder info
--------------------------------------------------------------------------------*/
/* Additional size deltas to be added to partition size */

#if qNames
#define kNamesSizeDelta 50
#else
#define kNamesSizeDelta 0
#endif

#if qDebug
#define kDebugSizeDelta 0
#else
#define kDebugSizeDelta 0
#endif

#if qModelFarCode
#define kModelFarSizeDelta 0
#else
#define kModelFarSizeDelta 0
#endif

resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,				
	reserved,
	reserved,
	reserved,
	reserved,
	
	/* Suggested partition size */
	(5000 + kNamesSizeDelta + kDebugSizeDelta + kModelFarSizeDelta) * 1024,
	
	/* Minimum partition size */
	(3000 + kNamesSizeDelta + kDebugSizeDelta + kModelFarSizeDelta) * 1024
};

resource 'seg!' (kIconEditApp,
#if qNames
	"IconEditApp",
#endif
	purgeable) {
	{	"ARes";
		"GNonRes";
		"GClipboard";
		"GClose";
		"GFile";
		"GOpen";
		"GDoCommand";
		"GSelCommand";
		"GWriteFile";
		"GReadFile";
		"GFinder";
		"BBNonRes";
		"BBOpen";
		"GNonRes2";
		"GPrint";
		"GReadResource";
	};
};

resource 'res!' (kIconEditApp,
#if qNames
	"IconEditApp",
#endif
	purgeable) {
	{	"ARes";
	};
};

resource 'mem!' (132,
#if qNames
	"Additional Stack Space",
#endif
	purgeable) {
	0,
	0,
	500*1024,				// Add to temporary reserve
	500*1024,				// Add to permanent reserve
	49152			// Add to stack space
};

#if qPowerPC
#include "CodeFragmentTypes.r"

resource 'cfrg' (0, "Configuration Info") {
	{
		kPowerPC,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		0,
		0,
		kIsApp,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"IconEdit"
	}
};
#endif

/* ============================   Bundle Stuff   ============================== */

resource 'ICN#' (128, "Application Icon") {
	{
	$"0007 FF80 0008 0000 0008 7E20 0028 0120 0048 0120 0488 0120 0D08 0120 0808 0120"
	$"6608 0120 9908 0120 8108 FE20 8008 0020 8008 0020 4A00 0028 3400 3F24 80FC 4082"
	$"4300 8041 2401 3022 1401 C814 0BEE 7F8F 0402 0007 0211 0007 0120 8007 00A0 6007"
	$"0058 1FE7 0024 021F 0010 C407 0009 2800 0006 5000 0002 A800 0001 4800 0000 9000",
	
	$"0007 FF80 000F FFC0 001F FFE0 003F FFE0 007F FFE0 04FF FFE0 0DFF FFE0 0BFF FFE0"
	$"67FF FFE0 FFFF FFE0 FFFF FFE0 FFFF FFE0 FFFF FFF0 7FFF FFF8 7FFF FFFC FFFF FFFE"
	$"7FFF FFFF 3FFF FFFE 1FFF FFFC 0FFF FFFF 07FF FFFF 03FF FFFF 01FF FFFF 00FF FFFF"
	$"007F FFFF 003F FE1F 001F FC07 000F F800 0007 F000 0003 E800 0001 C800 0000 9000"
	}
};

resource 'ICN#' (129, "Document Icon") {
	{
	$"0FE7 FF80 0808 0000 0808 7E20 0808 0120 0008 0128 0408 0124 0C08 012E 0808 0122"
	$"6608 0122 9908 0122 8108 FE22 8008 0022 8008 0022 4A00 1F22 3400 0022 00FC 0022"
	$"0300 0002 0401 FFF2 0400 0008 03E0 1FE4 0810 0552 0810 00A9 0820 0001 0820 01FE"
	$"0818 0000 0804 0002 0800 C002 0801 2002 0802 5002 0800 8802 0800 0802 0FFF 93FE",

	$"0FFF FF80 0FFF FFC0 0FFF FFE0 0FFF FFF0 0FFF FFF8 0FFF FFFC 0FFF FFFE 0FFF FFFE"
	$"6FFF FFFE FFFF FFFE FFFF FFFE FFFF FFFE FFFF FFFE 7FFF FFFE 3FFF FFFE 0FFF FFFE"
	$"0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFF 0FFF FFFF 0FFF FFFE"
	$"0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE 0FFF FFFE"
	}
};

/* ----------------------------------------------------------------------------- */

type 'ICED' as 'STR ';

resource 'ICED' (0) {				/* Creator (or Signature) */
	"IconEdit";
};

/* ----------------------------------------------------------------------------- */

resource 'FREF' (128) {
	'APPL', 0, ""	/* Show files of type 'APPL' with ICN# with local ID 0 */
};

resource 'FREF' (129) {
	'ICON', 1, ""	/* Show files of type 'ICON' with ICN# with local ID 1 */
};

/* ----------------------------------------------------------------------------- */

resource 'BNDL' (128) {
	'ICED',		/* Application signature (creator) */
	0,			/* Resource ID of version data */
	{
		'ICN#',	/* This is how to map local ICN# ids into resource IDs */
		{
			0, 128;	/* Local ICN# 0 is in resource 128 */
			1, 129	/* Local ICN# 1 is in resource 129 */
		};
		'FREF',	/* This is how to map local FREF ids into resource IDs */
		{
			0, 128;	/* Local FREF 0 (arbitrary) is in resource 128 */
			1, 129	/* Local FREF 1 (also arbitrary) is in resource 129 */
		}
	}
};

/* ============================   About Box   ============================== */
resource 'DITL' (phAboutApp,
#if qNames
"phAboutApp",
#endif
	purgeable) {
	 {	/* array DITLarray: 3 elements */
		/* [1] */
		{160, 182, 180, 262},
		Button {
			enabled,
			"OK"
		};
		/* [2] */
		{10, 75, 150, 316},
		StaticText {
			disabled,
			"This sample program implements a\n"
			"simple icon editor with MacApp.\n"
			WRITTEN_WITH_MACAPP
		};
		/* [3] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			1
		}
	}
};

include "Defaults.rsrc"  'ALRT' (phAboutApp);		// Grab the default about box
include "Defaults.rsrc"  'STR#' (kDefaultCredits);	// Grab the default credits

/* ============================   Pencil Cursor   ============================== */

resource 'CURS' (kPencilCursorId, purgeable) {
	$"00F0 0088 0108 0190 0270 0220 0440 0440 0880 0880 1100 1E00 1C00 1800 10",
	$"00F0 00F8 01F8 01F0 03F0 03E0 07C0 07C0 0F80 0F80 1100 1200 1400 1800 10",
	{14, 3}
};

/* =============================   Icon Window   =============================== */

resource 'STR#' (1000, "Window titles", purgeable) {
	{	/* array StringArray: 1 elements */
		/* [1] */
		""
	}
};

resource 'View' (1000, purgeable) {MAThreeOh, 
	{
	ViewSignatureAndClassname
		{'wind', 531, "", 'WIND', enabled, noIdle, {}, MAThreeOh, 
		{50, 20}, {249, 249}, sizeVariable, sizeVariable, shown, doesntWantToBeTarget, 
		handlesCursor, letsSubViewsHandleCursor, noCursorID, 
		handlesHelp, letsSubViewsHandleHelp, noHelpID, 1, 
		NoDrawingEnvironment {}, 
		AdornerListSignatureAndClassname {NoIdentifier, AdornerList, AdornerElementSize, AdornerElementSizeShift, DynamicArrayAllocationIncrement, {
			AdornFirst, AdornerLocalObject {EraseAdorner}, 
			DrawView, AdornerLocalObject {DrawAdorner}, 
			AdornLast, AdornerLocalObject {ResizeIconAdorner}}}, emptyUserArea, 
		Window {zoomDocProc, 'ICON', goAwayBox, resizable, ignoreFirstClick, 
			freeOnClosing, disposeOnFree, closesDocument, openWithDocument, dontAdaptToScreen, stagger, forceOnScreen, 
			dontCenter, doesntFloat, doesntHideOnSuspend, generateActivates, filler, 1000, 1}, 3}, 
	ViewSignatureAndClassname
		{'scrl', 183, "", 'SCLR', enabled, noIdle, {}, MAThreeOh, 
		{0, 0}, {234, 234}, sizeRelSuperView, sizeRelSuperView, shown, doesntWantToBeTarget, 
		handlesCursor, letsSubViewsHandleCursor, noCursorID, 
		handlesHelp, letsSubViewsHandleHelp, noHelpID, 1, 
		NoDrawingEnvironment {}, 
		NoAdorners {}, emptyUserArea, 
		Scroller {'vCLR', 'hCLR', {234, 234}, {16, 16}, VertConstrain, HorzConstrain, noInset, respondsToFKeys}, 1}, 
	ViewSignatureAndClassname
		{'inc@', 72, "", noID, enabled, noIdle, {}, MAThreeOh, 
		{0, 0}, {234, 234}, sizeVariable, sizeVariable, shown, doesntWantToBeTarget, 
		handlesCursor, letsSubViewsHandleCursor, noCursorID, 
		handlesHelp, letsSubViewsHandleHelp, noHelpID, 1, 
		NoDrawingEnvironment {}, 
		NoAdorners {}, emptyUserArea, 
		IncludeAt {1001, {0, 0}}, 
		NoSubviews}, 
	ViewSignatureAndClassname
		{'ssbr', 101, "", 'hCLR', enabled, noIdle, {}, MAThreeOh, 
		{234, -1}, {16, 236}, sizeVariable, sizeVariable, shown, doesntWantToBeTarget, 
		handlesCursor, letsSubViewsHandleCursor, noCursorID, 
		handlesHelp, letsSubViewsHandleHelp, noHelpID, 1, 
		NoDrawingEnvironment {}, 
		NoAdorners {}, emptyUserArea, 
		ScrollerScrollBar {mHScrollBarHit, notHilited, notDimmed, sizeable, noInset, 128, dontPreferOutline, h, 0, 0, 0}, 
		NoSubviews}, 
	ViewSignatureAndClassname
		{'ssbr', 101, "", 'vCLR', enabled, noIdle, {}, MAThreeOh, 
		{-1, 234}, {236, 16}, sizeVariable, sizeVariable, shown, doesntWantToBeTarget, 
		handlesCursor, letsSubViewsHandleCursor, noCursorID, 
		handlesHelp, letsSubViewsHandleHelp, noHelpID, 1, 
		NoDrawingEnvironment {}, 
		NoAdorners {}, emptyUserArea, 
		ScrollerScrollBar {mVScrollBarHit, notHilited, notDimmed, sizeable, noInset, 128, dontPreferOutline, v, 0, 0, 0}, 
		NoSubviews}
	}
};

resource 'View' (1001, purgeable) {MAThreeOh, 
	{
	ViewSignatureAndClassname
		{'view', 75, "TIconEditView", 'ICON', enabled, noIdle, {}, MAThreeOh, 
		{0, 0}, {234, 234}, sizeVariable, sizeVariable, shown, doesntWantToBeTarget, 
		handlesCursor, letsSubViewsHandleCursor, kPencilCursorId, 
		handlesHelp, letsSubViewsHandleHelp, noHelpID, 1, 
		NoDrawingEnvironment {}, 
		NoAdorners {}, emptyUserArea, 
		View {}, 
		NoSubviews}
	}
};
/*
resource 'view' (kIconWindowId, purgeable) {
	{
		root, 'WIND', { 50, 20 }, { kIconWindowHeight, kIconWindowWidth },
		sizeVariable, sizeVariable, shown, enabled,
		Window		{ "TWindow", zoomDocProc, goAwayBox, resizable, modeless,
					ignoreFirstClick, freeOnClosing, disposeOnFree, closesDocument,
					openWithDocument, dontAdaptToScreen, stagger, forceOnScreen,
					dontCenter, 'ICON', "" };

		'WIND', 'SCLR',	{ 0, 0 },
		{ kIconWindowHeight-kSBarSizeMinus1, kIconWindowWidth-kSBarSizeMinus1 },
		sizeRelSuperView, sizeRelSuperView, shown, enabled,
		Scroller	{ "TScroller", vertScrollBar, horzScrollBar, 0, 0, 16, 16,
					vertConstrain, horzConstrain, { 0, 0, 0, 0 } };

		'SCLR', IncludeViews	{ kIconEditViewId }
	}
};

resource 'view' (kIconEditViewId, purgeable) {
	{
		root, 'ICON', { 0, 0 }, { kIconViewHeight, kIconViewWidth },
		sizeVariable, sizeVariable, shown, enabled,
		View		{ "TIconEditView"}
	}
};
*/
/* ==============================   Seed Icon   ================================ */

resource 'ICON' (kSeedIconId, purgeable) {
	$"0001 0000 0002 8000 0004 4000 0008 2000 0010 1000 0020 0800 0040 0400 0080 0200"
	$"0100 0100 0200 0080 0400 0040 0800 0020 1000 0010 2000 0008 4000 3F04 8000 4082"
	$"4000 8041 2001 3022 1001 C814 080E 7F8F 0402 3007 0201 0007 0100 8007 0080 6007"
	$"0040 1FE7 0020 021F 0010 0407 0008 0800 0004 1000 0002 2000 0001 4000 0000 8000"
};

/* ================================   Menus   ================================== */

// Include the default Apple, File and Edit menus

include "Defaults.rsrc" 'CMNU' (mApple);
include "Defaults.rsrc" 'CMNU' (mFile);
include "Defaults.rsrc" 'CMNU' (mEdit);


/* ------------------------------------------------------------------------------ */

resource 'CMNU' (mIcon) {
	mIcon,
	textMenuProc,
	allEnabled,
	enabled,
	"Icon",
	 {
	/* [1] */	"Zoom In", 			noIcon, "M",	noMark, plain,	cZoomIn;
	/* [2] */	"Zoom Out", 		noIcon, "L", 	noMark, plain,	cZoomOut;
	/* [3] */	"-",				noIcon,	noKey,	noMark,	plain,	nocommand;
	/* [4] */	"Invert", 			noIcon, "I", 	noMark, plain,	cInvert;
	/* [5] */ 	"-",				noIcon, noKey,	noMark, plain,	nocommand;
	/* [6] */	"Set Color",		noIcon, noKey,  noMark, plain,	cSetColor
	}
};

/* ------------------------------------------------------------------------------ */

resource 'CMNU' (mBuzzwords) {
	mBuzzwords,
	textMenuProc,
	allEnabled,
	enabled,
	"Buzzwords",
	 {
	/* [1] */	"Page Setup Change", noIcon, noKey, noMark, plain, cChangePrinterStyle;
	/* [2] */	"Drawing", noIcon, noKey, noMark, plain, cDrawCommand;
	/* [3] */	"Set Color", noIcon, noKey, noMark, plain, cSetColor
	}
};

/* ------------------------------------------------------------------------------ */

resource 'MBAR' (kMBarDisplayed,
#if qNames
"IconEdit",
#endif
	purgeable) {
	 {mApple; mFile; mEdit; mIcon} 
};

/* ============================   Scripting Stuff   ============================== */

resource 'aedt' (kAEIconEditDispatchTable, 
#if qNames
	"IconEdit Events",
#endif
	purgeable) {
	{	/* array: 4 elements */
		/* [1] */
		'ICED', 'INVT', 1002,
		/* [2] */
		'ICED', 'ZmIn', 1000,
		/* [3] */
		'ICED', 'ZmOt', 1001,
		/* [4] */
		'ICED', 'DrPt', 1004
	}
};

/* ------------------------------------------------------------------------------ */

resource kAETerminologyExtension (0, 
#if qNames
	"English Terminology",
#endif
	purgeable) {
	0x1,
	0x0,
	english,
	roman,
	{	/* array Suites: 4 elements */

//========================================================================================
// Required Suite
//========================================================================================

		/* [1] */
		"Required Suite",
		"Terms that every application should support",
		kAERequiredSuite,
		1,
		1,
//----------------------------------------------------------------------------------------
// Events
//----------------------------------------------------------------------------------------
		{	/* array Events: 0 elements */
		},
//----------------------------------------------------------------------------------------
// Classes
//----------------------------------------------------------------------------------------
		{	/* array Classes: 0 elements */
		},
//----------------------------------------------------------------------------------------
// ComparisonOps
//----------------------------------------------------------------------------------------
		{	/* array ComparisonOps: 0 elements */
		},
//----------------------------------------------------------------------------------------
// Enumerations
//----------------------------------------------------------------------------------------
		{	/* array Enumerations: 0 elements */
		},

//========================================================================================
// Standard Suite
//========================================================================================

		/* [2] */
		"Standard Suite",
		"Common terms for most applications",
		'CoRe',
		1,
		1,
//----------------------------------------------------------------------------------------
// Events
//----------------------------------------------------------------------------------------
		{	/* array Events: 14 elements */
			/* [1] */
		"close", "Close an object", kAECoreSuite, kAEClose, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object to close",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 2 elements */
				/* [1] */
			"saving", keyAESaveOptions, enumSaveOptions,
				"specifies whether changes should be saved before closing",
				optional, singleItem, enumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,
				/* [2] */
			"saving in", keyAEFile, typeAlias,
				"the file in which to save the object",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
			/* [2] */
		"count", "Return the number of elements of a particular class within an object",
			kAECoreSuite, kAECountElements,
			typeLongInteger,
			"the number of elements",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object whose elements are to be counted",
			directParamRequired, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 1 elements */
				/* [1] */
			"each", keyAEObjectClass, cType,
				"the class of the elements to be counted",
				required, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
			/* [3] */
		"data size", "Return the size in bytes of an object", kAECoreSuite, kAEGetDataSize,
			cLongInteger,
			"the size of the object in bytes",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object whose data size is to be returned",
			directParamRequired, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 1 elements */
				/* [1] */
			"as", keyAERequestedType, cType,
				"the data type for which the size is calculated",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
			/* [4] */
		"delete", "Delete an element from an object", kAECoreSuite, kAEDelete,
			noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the element to delete",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [5] */
		"duplicate", "Duplicate objects(s)", kAECoreSuite, kAEClone,
			typeObjectSpecifier,
			"",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object(s) to duplicate",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 1 elements */
				/* [1] */
			"to", keyAEInsertHere, typeInsertionLoc,
				"the new location for the object(s)",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
			/* [6] */
		"exists", "Verify if an object exists", kAECoreSuite, kAEDoObjectsExist,
			typeBoolean,
			"true if it exists, false if not",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object in question",
			directParamRequired, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [7] */
		"make", "Make a new element", kAECoreSuite, kAECreateElement,
			typeObjectSpecifier,
			"to the new object(s)",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			noParams,
			"",
			directParamOptional, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 4 elements */
				/* [1] */
			"new", keyAEObjectClass, cType,
				"the class of the new element.",
				required, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,
				/* [2] */
			"at", keyAEInsertHere, typeInsertionLoc,
				"the location at which to insert the element",
				required, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,
				/* [3] */
			"with data", keyAEData, typeWildCard,
				"the initial data for the element",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,
				/* [4] */
			"with properties", keyAEPropData, 'reco',
				"the initial values for the properties of the element",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
			/* [8] */
		"move", "Move object(s) to a new location", kAECoreSuite, kAEMove,
			typeObjectSpecifier,
			"to the object(s) after they have been moved",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object(s) to move",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 1 elements */
				/* [1] */
			"to", keyAEInsertHere, typeInsertionLoc,
				"the new location for the object(s)",
				required, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
			/* [9] */
		"open",
			"Open the specified object(s)", kCoreEventClass, kAEOpen, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"list of objects to open",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [10] */
		"print",
			"Print the specified object(s)", kCoreEventClass, kAEPrint, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"list of objects to print",
			directParamRequired, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [11] */
		"quit",
			"Quit an application program", kCoreEventClass, kAEQuitApplication, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			noParams,
			"",
			directParamOptional, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [12] */
		"save",
			"Save an object", kAECoreSuite, kAESave, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object to save",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 3 elements */
				/* [1] */
			"in", keyAEFile, typeAlias,
				"the file in which to save the object",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,
				/* [2] */
			"as", keyAEFileType, cType,
				"the file type of the document in which to save the data",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,
				/* [3] */
			"makeCopy", keyAESaveCopy, cBoolean,
				"save a copy of the document without effecting the original",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
			/* [13] */
		"get",
			"Get the data for an object", kAECoreSuite, kAEGetData, typeWildCard,
			"the data from the object",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object whose data is to be returned",
			directParamRequired, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 1 elements */
				/* [1] */
			"as", keyAERequestedType, cType,
				"the desired types for the data, in order of preference",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
			/* [14] */
		"set",
			"Set an objects data", kAECoreSuite, kAESetData, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object to change",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 1 elements */
				/* [1] */
			"to", keyAEData, typeWildCard,
				"the new value",
				required, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			}
		},
//----------------------------------------------------------------------------------------
// Classes
//----------------------------------------------------------------------------------------
		{	/* array Classes: 16 elements */
			/* [1] */
		"application", cApplication,
			"An application program",
			{	/* array Properties: 6 elements */
				/* [1] */
			"clipboard", pClipboard, typeWildCard,
				"the clipboard", reserved,
				listOfItems,
				notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"frontmost", pIsFrontProcess, typeBoolean,
				"Is this the frontmost application?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"name", pName, typeIntlText,
				"the name", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [4] */
			"selection", pUserSelection, cSelection,
				"the selection visible to the user", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [5] */
			"version", pVersion, cVersion,
				"the version number of the application", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [6] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				},
			{	/* array Elements: 2 elements */
				/* [1] */
				cDocument,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				},
				/* [2] */
				cWindow,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				},
				/* [3] */
				cPalette,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				}
			},
			/* [2] */
			"applications",
			cApplication,
			"Every application",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [3] */
		"character", cChar,
			"A character",
			{	/* array Properties: 7 elements */
				/* [1] */
			"color", pColor, cRGBColor,
				"the color", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"font", keyAEFont, cText,
				"the name of the font", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"size", pPointSize, cFixed,
				"the size in points", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [4] */
			"writing code", pScriptTag, cIntlWritingCode,
				"the script system and language", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [5] */
			"style", pTextStyles, cTextStyles,
				"the text style", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [6] */
			"uniform styles", pUniformStyles, cTextStyles,
				"the text style", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [7] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
			},
			{	/* array Elements: 2 elements */
				/* [1] */
				cChar,
				{	/* array KeyForms: 1 elements */
					/* [1] */
					formAbsolutePosition
				},
				/* [2] */
				cText,
				{	/* array KeyForms: 1 elements */
					/* [1] */
					formAbsolutePosition
				}
			},
			/* [4] */
		"characters", cChar,
			"Every character",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [5] */
		"document", cDocument,
			"A document",
			{	/* array Properties: 4 elements */
				/* [1] */
			"modified", pIsModified, cBoolean,
				"Has the document been modified since the last save?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"name", pName, cIntlText,
				"the name", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"selection", pSelection, cSelection,
				"the selection visible to the user", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [4] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				},
			{	/* array Elements: 1 elements */
				/* [1] */
				cFile,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				}
			},
			/* [6] */
		"documents", cDocument,
			"Every document",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [7] */
		"file", cFile,
			"A file",
			{	/* array Properties: 3 elements */
				/* [1] */
			"stationery", pIsStationeryPad, cBoolean,
				"Is the file a stationery file?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"name", pName, cIntlText,
				"the name", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
			},
			{	/* array Elements: 0 elements */
			},
			/* [8] */
		"files", cFile,
			"Every file",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [9] */
		"selection-object", cSelection,
			"the selection visible to the user",
			{	/* array Properties: 2 elements */
				/* [1] */
			"contents", pContents, cType,
				"the contents of the selection", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
			},
			{	/* array Elements: 0 elements */
			},
			/* [10] */
		"text", cText,
			"Text",
			{	/* array Properties: 8 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural,
				/* [2] */
			"color", pColor, cRGBColor,
				"the color of the first character", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"font", pFont, cText,
				"the name of the font of the first character", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [4] */
			"size", pPointSize, cFixed,
				"the size in points of the first character", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [5] */
			"writing code", pScriptTag, cIntlWritingCode,
				"the script system and language of the first character", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [6] */
			"style", pTextStyles, cTextStyles,
				"the text style of the first character", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [7] */
			"uniform styles", pUniformStyles, cTextStyles,
				"the text styles that are uniform throughout the text", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [8] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
			},
			{	/* array Elements: 2 elements */
				/* [1] */
			cChar,
				{	/* array KeyForms: 1 elements */
					/* [1] */
					formAbsolutePosition
				},
				/* [2] */
			cText,
				{	/* array KeyForms: 1 elements */
					/* [1] */
					formAbsolutePosition
				}
			},
			/* [11] */
			"text style info",
			cTextStyles,
			"On and Off styles of text run",
			{	/* array Properties: 2 elements */
				/* [1] */
			"on styles", keyAEOnStyles, enumStyle,
				"the styles that are on for the text", reserved,
				listOfItems, enumerated,
				readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"off styles", keyAEOffStyles, enumStyle,
				"the styles that are off for the text", reserved,
				listOfItems, enumerated,
				readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular
			},
			{	/* array Elements: 0 elements */
			},
			/* [12] */
			"text style infos",
			cTextStyles,
			"every text style info",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [13] */
		"window", cWindow,
			"A window",
			{	/* array Properties: 13 elements */
				/* [1] */
			"bounds", pBounds, cQDRectangle,
				"the boundary rectangle for the window", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"closeable", pHasCloseBox, cBoolean,
				"Does the window have a close box?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"titled", pHasTitleBar, cBoolean,
				"Does the window have a title bar?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [4] */
			"index", pIndex, cLongInteger,
				"the number of the window", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [5] */
			"modal", pIsModal, cBoolean,
				"Is the window modal?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [6] */
			"resizable", pIsResizable, cBoolean,
				"Is the window resizable?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [7] */
			"zoomable", pIsZoomable, cBoolean,
				"Is the window zoomable?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [8] */
			"zoomed", pIsZoomed, cBoolean,
				"Is the window zoomed?", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [9] */
			"name", pName, cIntlText,
				"the title of the window", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [10] */
			"selection", pSelection, cSelection,
				"the selection visible to the user", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [11] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
			},
			{	/* array Elements: 1 elements */
				/* [1] */
				cDocument,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				}
			},
			/* [14] */
		"windows", cWindow,
			"Every window",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [15] */
		"palette", cPalette,
			"A floating palette",
			{	/* array Properties: 11 elements */
				/* [1] */
			"bounds", pBounds, cQDRectangle,
				"the boundary rectangle for the palette", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"closeable", pHasCloseBox, cBoolean,
				"Does the palette have a close box?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"titled", pHasTitleBar, cBoolean,
				"Does the palette have a title bar?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [4] */
			"index", pIndex, cLongInteger,
				"the number of the palette", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [5] */
			"floating", pIsFloating, cBoolean,
				"Does the palette float?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [6] */
			"resizable", pIsResizable, cBoolean,
				"Is the palette resizable?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [7] */
			"zoomable", pIsZoomable, cBoolean,
				"Is the palette zoomable?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [8] */
			"zoomed", pIsZoomed, cBoolean,
				"Is the palette zoomed?", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [9] */
			"name", pName, cIntlText,
				"the title of the palette", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [10] */
			"selection", pSelection, cSelection,
				"the selection visible to the user", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [11] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				},
			{	/* array Elements: 0 elements */
			},
			/* [16] */
		"palettes", cPalette,
			"Every palette",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [17] */
		"insertion point", cInsertionPoint,
			"An insertion location between two objects",
			{	/* array Properties: 1 element */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
			},
			{	/* array Elements: 0 elements */
			},
			/* [18] */
		"insertion points", cInsertionPoint,
			"Every insertion location",
			{	/* array Properties: 1 elements */
				/* [1] */
				"",
				kAESpecialClassProperties,
				cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			}
		},
//----------------------------------------------------------------------------------------
// ComparisonOps
//----------------------------------------------------------------------------------------
		{	/* array ComparisonOps: 8 elements */
			"starts with", kAEBeginsWith, "Starts with",
			"contains", kAEContains, "Contains",
			"ends with", kAEEndsWith, "Ends with",
			"=", kAEEquals, "Equal",
			">", kAEGreaterThan, "Greater than",
			"", kAEGreaterThanEquals, "Greater than or equal to",
			"<", kAELessThan, "Less than",
			"", kAELessThanEquals, "Less than or equal to"
		},
//----------------------------------------------------------------------------------------
// Enumerations
//----------------------------------------------------------------------------------------
		{	/* array Enumerations: 2 elements */
			/* [1] */
			enumSaveOptions,
			{	/* array Enumerators: 3 elements */
				"yes", kAEYes, "Save objects now",
				"no", kAENo, "Do not save objects",
				"ask", kAEAsk, "Ask the user whether to save"
			},
			/* [2] */
			enumKeyForm,
			{	/* array Enumerators: 3 elements */
				"index", formAbsolutePosition, "keyform designating indexed access",
				"named", formName, "keyform designating named access",
				"ID", formUniqueID, "keyform designating access by unique identifer"
			}
		},

//========================================================================================
// Miscellaneous Standards
//========================================================================================

		/* [3] */
	"Miscellaneous Standards",
		"Miscellaneous standard events and classes",
		'misc',
		1,
		1,
//----------------------------------------------------------------------------------------
// Events
//----------------------------------------------------------------------------------------
		{	/* array Events: 12.1 elements */
			/* [11.1] */
		"revert", "Revert an object to its last saved state",
			kAEMiscStandards, kAERevert, 
			noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"list of object(s) to revert",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [1] */
		"cut", "Cut an object to the clipboard", kAEMiscStandards, kAECut,
			noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			noParams,
			"",
			directParamOptional, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [2] */
		"copy", "Copy an object to the clipboard", kAEMiscStandards, kAECopy,
			noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			noParams,
			"",
			directParamOptional, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [3] */
		"paste", "Paste an object from the clipboard", kAEMiscStandards, kAEPaste,
			noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			noParams,
			"",
			directParamOptional, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [4] */
		"redo", "Reverse the action of the immediately preceeding undo", kAEMiscStandards, kAERedo,
			noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			noParams,
			"",
			directParamOptional, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [5] */
		"undo", "Undo the action of the previous event or user interaction", kAEMiscStandards, kAEUndo,
			noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			noParams,
			"",
			directParamOptional, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			}
		},
//----------------------------------------------------------------------------------------
// Classes
//----------------------------------------------------------------------------------------
		{	/* array Classes: 4 elements */
			/* [1] */
			"menu",
			'cmnu',
			"A menu",
			{	/* array Properties: 3 elements */
				/* [1] */
			"class", 'pcls', 'type',
				"The class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"menu ID", 'mnid', 'shor',
				"the menu ID for the menu", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"name", 'pnam', 'itxt',
				"the name", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular
			},
			{	/* array Elements: 1 elements */
				/* [1] */
				'cmen',
				{	/* array KeyForms: 2 elements */
					/* [1] */
					'indx',
					/* [2] */
					'name'
				}
			},
			/* [2] */
		"menus", 'cmnu',
			"Every menu",
			{	/* array Properties: 1 elements */
				/* [1] */
			"class attributes", 'c@#!', 'type',
				"the best descriptor type", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},
			/* [3] */
		"menu item", 'cmen',
			"A menu item",
			{	/* array Properties: 4 elements */
				/* [1] */
			"class", 'pcls', 'type',
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"enabled", 'enbl', 'bool',
				"Is the menu item is enabled?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"item number", 'itmn', 'shor',
				"the menu item number", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [4] */
			"name", 'pnam', 'itxt',
				"The name", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular
			},
			{	/* array Elements: 0 elements */
			},
			/* [4] */
		"menu items", 'cmen',
			"Every menu item",
			{	/* array Properties: 1 elements */
				/* [1] */
			"Class attributes", 'c@#!', 'type',
				"The best descriptor type", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			}
		},
//----------------------------------------------------------------------------------------
// ComparisonOps
//----------------------------------------------------------------------------------------
		{	/* array ComparisonOps: 0 elements */
		},
//----------------------------------------------------------------------------------------
// Enumerations
//----------------------------------------------------------------------------------------
		{	/* array Enumerations: 1 element */
			/* [1] */
			enumQuality,
			{	/* array Enumerators: 3 elements */
				"draft", kAEFast, "image the graphic as quickly as possible",
				"regular", kAERegular, "image the graphic normally",
				"high", kAEHiQuality, "image the graphic at the highest quality possible"
			}
		},

//========================================================================================
// IconEdit Suite
//========================================================================================

		/* [4] */
	"IconEdit Suite",
		"Events that are specific to the IconEdit application",
		'ICED',
		1,
		1,
		{	/* array Events: 4 elements */
			/* [1] */
			"invert",
			"Inverts a windows contents",
			'ICED',
			'INVT',
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			notTightBindingFunction,
			Reserved8,
			verbEvent,
			Reserved3,
			typeObjectSpecifier,
			"the object to invert",
			directParamRequired,
			singleItem,
			notEnumerated,
			changesState,
			Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [2] */
			"zoom_in",
			"increases the magnification of the target document",
			'ICED',
			'ZmIn',
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			notTightBindingFunction,
			Reserved8,
			verbEvent,
			Reserved3,
			typeObjectSpecifier,
			"the document to zoom into",
			directParamRequired,
			singleItem,
			notEnumerated,
			doesntChangeState,
			Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [3] */
			"zoom_out",
			"decreases the magnification of the targe"
			"t document",
			'ICED',
			'ZmOt',
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			notTightBindingFunction,
			Reserved8,
			verbEvent,
			Reserved3,
			typeObjectSpecifier,
			"the document to zoom out of",
			directParamRequired,
			singleItem,
			notEnumerated,
			doesntChangeState,
			Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			/* [4] */
			"draw_points",
			"draw or erase a list of points in the specified view.",
			'ICED',
			'DrPt',
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			notTightBindingFunction,
			Reserved8,
			verbEvent,
			Reserved3,
			typeObjectSpecifier,
			"the document containing the bitmap to draw in",
			directParamRequired,
			singleItem,
			notEnumerated,
			doesntChangeState,
			Reserved12,
			{	/* array OtherParams: 2 elements */
				/* [1] */
				"points",
				'kPtL',
				cAEList,
				"list of points to draw or erase",
				required,
				listOfItems,
				notEnumerated,
				Reserved9,
				prepositionParam,
				notFeminine,
				notMasculine,
				singular,
				/* [2] */
				"do_erase",
				'kErs',
				typeBoolean,
				"optional parameter to erase points (default is to draw points)",
				optional,
				singleItem,
				notEnumerated,
				Reserved9,
				prepositionParam,
				notFeminine,
				notMasculine,
				singular
			}
		},
		{	/* array Classes: 1 elements */
			/* [1] */
			"document",
			cDocument,
			"IconEdit document",
			{	/* array Properties: 1 elements */
				/* [1] */
				"icon_color",
				pColor,
				cRGBColor,
				"color in which the icon is drawn",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				Reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular
			},
			{	/* array Elements: 0 elements */
			}
		},
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 0 elements */
		}
	}
};



