//----------------------------------------------------------------------------------------
// TDL_AETerminologyExtension.r
// ETO20 MacApp 3.3.1, MPW 3.4.1
// Copyright 1996 Conrad Kopala
// Twist Down Lists version 2.0a0 7/15/96
//----------------------------------------------------------------------------------------
#ifndef __TDLAETERMINOLOGYEXTENSION__
#define __TDLAETERMINOLOGYEXTENSION__

#ifndef __AEREGISTRY.R__
#include "AERegistry.r"
#endif

#ifndef __AEUSERTERMTYPES__
#include "AEUserTermTypes.r"
#endif

#ifndef __APPLEEVENTS_R__
#include "AppleEvents.r"
#endif

#include "TwistDownGlobals.r"

resource kAETerminologyExtension (0, 
#if qNames
	"English Terminology",
#endif
	purgeable) {
	0x1,
	0x0,
	english,
	roman,
	{	/* array Suites: 4 elements */

//========================================================================================
// Required Suite
//========================================================================================

		/* [1] */
		"Required Suite",
		"Terms that every application should support",
		kAERequiredSuite,
		1,
		1,
//----------------------------------------------------------------------------------------
// Events
//----------------------------------------------------------------------------------------
		{	/* array Events: 0 elements */
		},
//----------------------------------------------------------------------------------------
// Classes
//----------------------------------------------------------------------------------------
		{	/* array Classes: 0 elements */
		},
//----------------------------------------------------------------------------------------
// ComparisonOps
//----------------------------------------------------------------------------------------
		{	/* array ComparisonOps: 0 elements */
		},
//----------------------------------------------------------------------------------------
// Enumerations
//----------------------------------------------------------------------------------------
		{	/* array Enumerations: 0 elements */
		},

//========================================================================================
// Standard Suite
//========================================================================================

		/* [2] */
		"Standard Suite",
		"Common terms for most applications",
		'CoRe',
		1,
		1,
//----------------------------------------------------------------------------------------
// Events
//----------------------------------------------------------------------------------------
{	/* array Events: 14 elements */
/* [1] */	"close", "Close an object", kAECoreSuite, kAEClose, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object to close",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 2 elements */
				/* [1] */
			"saving", keyAESaveOptions, enumSaveOptions,
				"specifies whether changes should be saved before closing",
				optional, singleItem, enumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,
				/* [2] */
			"saving in", keyAEFile, typeAlias,
				"the file in which to save the object",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},

/* [6] */	
			"exists", "Verify if an object exists", kAECoreSuite, kAEDoObjectsExist,
			typeBoolean,
			"true if it exists, false if not",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object in question",
			directParamRequired, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},


/* [9] */	
			"open","Open the specified object(s)", kCoreEventClass, kAEOpen, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"list of objects to open",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},

/* [11] */	"quit","Quit an application program", kCoreEventClass, kAEQuitApplication, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			noParams,
			"",
			directParamOptional, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 0 elements */
			},

/* [13] */"get","Get the data for an object", kAECoreSuite, kAEGetData, typeWildCard,
			"the data from the object",
			replyRequired, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object whose data is to be returned",
			directParamRequired, singleItem, notEnumerated, doesntChangeState, Reserved12,
			{	/* array OtherParams: 1 elements */
				/* [1] */
			"as", keyAERequestedType, cType,
				"the desired types for the data, in order of preference",
				optional, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			},
/* [14] */	"set","Set an objects data", kAECoreSuite, kAESetData, noReply,
			"",
			replyOptional, singleItem, notEnumerated, notTightBindingFunction, Reserved8, verbEvent, Reserved3,
			typeObjectSpecifier,
			"the object to change",
			directParamRequired, singleItem, notEnumerated, changesState, Reserved12,
			{	/* array OtherParams: 1 elements */
				/* [1] */
			"to", keyAEData, typeWildCard,
				"the new value",
				required, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular
			}
		},
//----------------------------------------------------------------------------------------
// Classes
//----------------------------------------------------------------------------------------
		{	/* array Classes: 16 elements */
/* [1] */	"application", cApplication,"An application program",
			{	/* array Properties: 6 elements */
				/* [1] */
			"clipboard", pClipboard, typeWildCard,
				"the clipboard", reserved,
				listOfItems,
				notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"frontmost", pIsFrontProcess, typeBoolean,
				"Is this the frontmost application?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"name", pName, typeIntlText,
				"the name", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [5] */
			"version", pVersion, cVersion,
				"the version number of the application", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [6] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				},
			{	/* array Elements: 2 elements */
				/* [1] */
				cDocument,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				},
				/* [2] */
				cWindow,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				}
			},
/* [2] */	"applications",cApplication,"Every application",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},

/* [5] */	"document", cDocument,"A document",
			{	/* array Properties: 4 elements */

				/* [2] */
			"name", pName, cIntlText,
				"the name", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [4] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				},
			{	/* array Elements: 0 elements */
			},
/* [6] */	"documents", cDocument,"Every document",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},


/* [13] */	"window", cWindow,"A window",
			{	/* array Properties: 13 elements */
				/* [1] */
			"bounds", pBounds, cQDRectangle,
				"the boundary rectangle for the window", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [2] */
			"closeable", pHasCloseBox, cBoolean,
				"Does the window have a close box?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [3] */
			"titled", pHasTitleBar, cBoolean,
				"Does the window have a title bar?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [4] */
			"index", pIndex, cLongInteger,
				"the number of the window", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [5] */
			"modal", pIsModal, cBoolean,
				"Is the window modal?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [6] */
			"resizable", pIsResizable, cBoolean,
				"Is the window resizable?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [7] */
			"zoomable", pIsZoomable, cBoolean,
				"Is the window zoomable?", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [8] */
			"zoomed", pIsZoomed, cBoolean,
				"Is the window zoomed?", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				/* [9] */
			"name", pName, cIntlText,
				"the title of the window", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [11] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
			},
			{	/* array Elements: 1 elements */
				/* [1] */
				cDocument,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				}
			},
/* [14] */	"windows", cWindow,"Every window",
			{	/* array Properties: 1 elements */
				/* [1] */
			"", kAESpecialClassProperties, cType,
				"", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, plural
			},
			{	/* array Elements: 0 elements */
			},



		},
//----------------------------------------------------------------------------------------
// ComparisonOps
//----------------------------------------------------------------------------------------
		{	/* array ComparisonOps: 8 elements */
			"starts with", kAEBeginsWith, "Starts with",
			"contains", kAEContains, "Contains",
			"ends with", kAEEndsWith, "Ends with",
			"=", kAEEquals, "Equal",
			">", kAEGreaterThan, "Greater than",
			"", kAEGreaterThanEquals, "Greater than or equal to",
			"<", kAELessThan, "Less than",
			"", kAELessThanEquals, "Less than or equal to"
		},
//----------------------------------------------------------------------------------------
// Standard Suite Enumerations
//----------------------------------------------------------------------------------------
		{	/* array Enumerations: 2 elements */
			/* [1] */
			enumSaveOptions,
			{	/* array Enumerators: 3 elements */
				"yes", kAEYes, "Save objects now",
				"no", kAENo, "Do not save objects",
				"ask", kAEAsk, "Ask the user whether to save"
			},
			/* [2] */
			enumKeyForm,
			{	/* array Enumerators: 3 elements */
				"index", formAbsolutePosition, "keyform designating indexed access",
				"named", formName, "keyform designating named access",
				"ID", formUniqueID, "keyform designating access by unique identifer"
			}
		},

//Miscellaneous suite removed
//========================================================================================
// TwistDownLists Suite
//========================================================================================

		/* [4] */
	"TwistDownLists Suite",
		"Events specific to the Twist Down Lists application",
		kAETwistDownListsSuite,
		1,
		1,
		{	/* array Events: 4 elements */
			/* [1] */
			"expand all",
			"Expands the whole twistDownList",
			kAETwistDownListsSuite,kAEExpandAllID,noReply,
			"",
			replyOptional,singleItem,notEnumerated,notTightBindingFunction,Reserved8,verbEvent,Reserved3,
			typeObjectSpecifier,
			"the twistDownList to expand",
			directParamRequired,singleItem,notEnumerated,doesntChangeState,Reserved12,
			{	/* array OtherParams: 0 elements */
			},
			
			/* [2] */
			"collapse all",
			"collapses the whole twistDownList",
			kAETwistDownListsSuite,kAECollapseAllID,noReply,
			"",
			replyOptional,singleItem,notEnumerated,notTightBindingFunction,Reserved8,verbEvent,Reserved3,
			typeObjectSpecifier,
			"the twistDownList to collapse",
			directParamRequired,singleItem,notEnumerated,doesntChangeState,Reserved12,
			{	/* array OtherParams: 0 elements */
			},

			/* [3] */			
			"expand",
			"expands a twistDownElement",
			kAETwistDownListsSuite,kAEExpandElementID,noReply,
			"",
			replyOptional,singleItem,notEnumerated,notTightBindingFunction,Reserved8,verbEvent,Reserved3,
			typeObjectSpecifier,
			"the twistDownElement to expand",
			directParamRequired,singleItem,notEnumerated,doesntChangeState,Reserved12,
			{	/* array OtherParams: 1 elements */
			"", keyAEObject, typeObjectSpecifier,
				"specifies the document",
				required, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,						
			},
			
			/* [4] */
			"collapse",
			"collapses a twistDownElement",
			kAETwistDownListsSuite,kAECollapseElementID,noReply,
			"",
			replyOptional,singleItem,notEnumerated,notTightBindingFunction,Reserved8,verbEvent,Reserved3,
			typeObjectSpecifier,
			"the twistDownElement to collapse",
			directParamRequired,singleItem,notEnumerated,doesntChangeState,Reserved12,
			{	/* array OtherParams: 0 elements */
			"", keyAEObject, typeObjectSpecifier,
				"specifies the document",
				required, singleItem, notEnumerated, Reserved9, prepositionParam, notFeminine, notMasculine, singular,						
			},
			

#if qDebug
			/* [5] */
			"reset object count",
			"sets the object count to zero",
			kAETwistDownListsSuite,kAEResetObjectCountID,noReply,
			"",
			replyOptional,singleItem,notEnumerated,notTightBindingFunction,Reserved8,verbEvent,Reserved3,
			noParams,
			"",
			directParamOptional,singleItem,notEnumerated,doesntChangeState,Reserved12,
			{	/* array OtherParams: 0 elements */
			},		
#endif
		},
		
		{	/* array Classes: 3 elements */


			
/* [1] */	"application", cApplication,"An application program",
			{	/* array Properties: 3 elements */
				/* [1] */
			"fShowInvisibleFiles", pShowInvisibleFiles, typeBoolean,
				"determines whether invisible files and folders will be read from the disk", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [2] */
			"gUseSystemDirection", pUseSystemDirection, typeBoolean,
				"determines whether the system writing direction will be used", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [3] */
			"gSendAppleEvents", pSendAppleEvents, typeBoolean,
				"determines whether Apple events are sent", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,			
			
				/* [4] */
			"gFailHere", pFailHere, typeBoolean,
				"the value of the FailHere flag", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,						

				/* [5] */
			"fAllowUnlimitedDocs", pUnlimitedDocs, typeBoolean,
				"allows the same disk to be opened as many times as desired", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,						
				
				/* [6] */
			"gAppleEventRouting", pAERouting, enumAERouting,
				"determines how Apple events will be routed", reserved,
				singleItem, enumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

#if qDebug
				/* [7] */
			"gObjectCountingEnabled", pObjectCountingEnabled, typeBoolean,
				"determines whether objects are counted", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,						

				/* [8] */
			"gPrintBaseClassInfo", pPrBaseClassInfo, typeBoolean,
				"determines whether TObject class object info is printed", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,						
				
				/* [9] */
			"gPrintMacAppClassInfo",  pPrMacAppClassInfo, typeBoolean,
				"determines whether MacApp class object info is printed", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,						
				
				/* [10] */
			"gPrintAppClassInfo",  pPrAppClassInfo, typeBoolean,
				"determines whether application class object info is printed", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,										

				/* [11] */
			"gAppUserFlag1",  pSetAppUserFlag1, typeBoolean,
				"the value of gAppUserFlag1", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,										
				
				/* [12] */
			"gAppUserFlag2",  pSetAppUserFlag2, typeBoolean,
				"the value of gAppUserFlag2", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,										
				
				/* [13] */
			"gAppUserFlag3",  pSetAppUserFlag3, typeBoolean,
				"the value of gAppUserFlag2", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,										
								
				
#endif
			
			},
			{	/* array Elements: 2 elements */
				/* [1] */
				cTwistDownView,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				},
				/* [2] */
				cTwistDownElement,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				}				
			},
		
/* [2] */	"twistDownView",cTwistDownView,"TwistDownLists view",
			{	/* array Properties: 5 elements */
				/* [1] */
			"name", pName, typeIntlText,
				"the name", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,			

				/* [2] */
			"font", pFontName, typeIntlText,
				"the name of the font of the twistDownView", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				
				/* [4] */
			"font size", pPointSize, cFixed,
				"the size in points", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [4] */
			"could expand all", pCouldExpand, cBoolean,
				"can the whole list be expanded", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				
				/* [4] */
			"could collapse all", pCouldCollapse, cBoolean,
				"can the whole list be collapsed", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [4] */
			"writing direction", pWritingDirection, enumWritingDirection,
				"the writing direction of the twistDownView", reserved,
				singleItem, enumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [5] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
	
			},
			{	/* array Elements: 0 elements */
			},


/* [3] */	"document", cDocument,"A document",
			{	/* array Properties: 4 elements */

				/* [1] */
			"font size", pPointSize, cFixed,
				"the size in points", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [2] */
			"font", pFontName, typeIntlText,
				"the name of the font of the twistDownView", reserved,
				singleItem, notEnumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				
				/* [3] */
			"number of folders ", pNumFolders, cLongFixed,
				"the number of folders in the list", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,				
				
				/* [4] */
			"number of files ", pNumFiles, cLongFixed,
				"the number of files in the list", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,				

				/* [5] */
			"number of items ", pNumItems, cLongFixed,
				"the total number of folders and files in the list", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,

				/* [6] */
			"search method", pSearchMethod, enumSearchMethod,
				"the method used to search the list of twistDownElements", reserved,
				singleItem, enumerated, readWrite, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				
			},
			{	/* array Elements: 2 elements */
				/* [1] */
				cTwistDownView,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				},
				/* [2] */
				cTwistDownElement,
				{	/* array KeyForms: 2 elements */
					/* [1] */
					formAbsolutePosition,
					/* [2] */
					formName
				}				
			},

/* [1] */	"twistDownElement", cTwistDownElement,"A twist down element",
			{	/* array Properties: 1 elements */
				/* [1] */
			"name", pName, typeIntlText,
				"the name of the twistDownElement", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,			

				/* [2] */
			"has sublist", pHasSubList, cBoolean,
				"the twistDownElement has a descendant twistDownElement", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,			
				
				/* [3] */
			"show sublist", pShowSubList, cBoolean,
				"the twistDownElement's descendant twistDownElement is to be shown", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,			

				/* [4] */
			"has control", pHasControl, cBoolean,
				"the twistDownElement has a twistDownControl", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,			
				
				/* [5] */
			"item in list", pItemInList, cLongFixed,
				"the absolute position of the twistDownElement in the list", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,			
				
				/* [6] */
			"indent level", pIndentLevel, cLongFixed,
				"the depth of the twistDownElement in the hierarchy", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,				

				/* [7] */
			"class", pClass, cType,
				"the class", reserved,
				singleItem, notEnumerated, readOnly, Reserved8, noApostrophe, notFeminine, notMasculine, singular,
				
			},

			{	/* array Elements: 0 elements */
			},
			
			
			
			
			
		},	//end classes
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 2 elements */	
		/* [1] */
			enumWritingDirection,
			{	/* array Enumerators: 2 elements */
				"left to right", kAELeftToRight, "left-to-right",
				"right to left", kAERightToLeft, "right-to-left"
			},
		/* [2] */
			enumAERouting,
			{	/* array Enumerators: 2 elements */
				"route to doc", kAERouteToDoc, "route to doc",
				"route to view", kAERouteToView, "route to view"
			},			
		/* [3] */
			enumSearchMethod,
			{	/* array Enumerators: 2 elements */
				"visible list only", kAEVisibleList, "visible list only",
				"whole list", kAEWholeList, "whole list"
			}			
		}
	}
};





#endif