//--------------------------------------------------------------------------------------------------																		
// Twist Down Lists.r
// ETO20 MacApp 3.3.1, MPW 3.4.1
// Copyright  1994-1996 by Conrad Kopala
// Twist Down Lists version 2.0a0 7/15/96
//--------------------------------------------------------------------------------------------------

//--------------------------------------------------------------------------------------------------
// INCLUDE FILES 
//--------------------------------------------------------------------------------------------------

// Standard Includes 

#ifndef __TYPES_R__
#include "Types.r"
#endif

#ifndef __SYSTYPES_R__
#include "SysTypes.r"
#endif

#ifndef __BalloonTypes__
#include "BalloonTypes.r"
#endif

#ifndef __MacAppTypes__
#include "MacAppTypes.r"
#endif

#ifndef __ViewTypes__
#include "ViewTypes.r"
#endif

#ifndef __MACAPPVERSION__
#include "MacAppVersion.h"
#endif

#ifndef __TDLCOPYRIGHT__
#include "TDLCopyright.h"
#endif


#if qDebug | qPerform
include "Debug.rsrc" not 'ckid';
#endif

include "Dialog.rsrc" not 'ckid';
include "MacApp.rsrc" not 'ckid';

// Includes for Building Blocks

include "Printing.rsrc" not 'ckid';

#include "TwistDownGlobals.r"
#include "TDLErrors.r"
#include "ProgressIndicators.r"
#include "BalloonHelp.r"

// Include Code Resources

#if !qPowerPC
include $$Shell("ObjApp")$$Shell("XAppName") 'CODE';
#endif

//--------------------------------------------------------------------------------------------------
// CONSTANTS 
//--------------------------------------------------------------------------------------------------

// Finder Information
// ------------------

#define kApplicationName	$$Shell("XAppName")

// Bundle Constants
// ------------------
#define kBundleID						128
#define kApplicationID			128
#define kDocumentID					129

// Memory Management Resources
// ---------------------------
#define kTwistDownAppSeg	1000
#define kTwistDownAppMem	1000
#define kTwistDownAppRes	1000

//--------------------------------------------------------------------------------------------------
// AppleEvent dispatch table
//--------------------------------------------------------------------------------------------------
resource 'aedt' (kTDLAEDispatchTable) {
	{
	kAETwistDownListsSuite, kAEExpandAllID,								cExpandAll;			//Event Class, Event ID, Value
	kAETwistDownListsSuite, kAECollapseAllID,							cCollapseAll;
	kAETwistDownListsSuite, kAEExpandElementID,						cExpandElement;			
	kAETwistDownListsSuite, kAECollapseElementID,					cCollapseElement;	

#if qDebug
	kAETwistDownListsSuite, kAEResetObjectCountID,				cResetObjectCount;
#endif
	}
};
//--------------------------------------------------------------------------------------------------
// Menu Bars 
//--------------------------------------------------------------------------------------------------
resource 'MBAR' (kMBarDisplayed,
#if qNames
kApplicationName,
#endif
	nonpurgeable) {
	{ mApple; mFile; mEdit; mFormatMenu; mControlMenu; mWindowsMenu
	
	#if qDebug
	;
	mTestMenu;
	#endif
	
	 }
};

resource 'MBAR' (kMBarHierarchical,
#if qNames
"kMBarHierarchical",
#endif
nonpurgeable) {
	{mFontMenu

	} 
};

//--------------------------------------------------------------------------------------------------
// Menus 
//--------------------------------------------------------------------------------------------------
include "Defaults.rsrc" 'CMNU' (mApple);	// Grab the default Apple menus
include "Defaults.rsrc" 'CMNU' (mFile);		// Grab the default File menus
include "Defaults.rsrc" 'CMNU' (mEdit);		// Grab the default Edit menu

resource 'CMNU' (mFormatMenu,
#if qNames
"Format Menu",
#endif
nonpurgeable) {
	mFormatMenu,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Format",
	 {
/* [ 1] */	"Use System Direction",	noIcon,	noKey,	noMark,	plain, cUseSystemDirection;
/* [ 2] */	"Right to Left",				noIcon,	noKey,	noMark,	plain, cWritingDirection; //this is toggled
/* [ 3] */	"-",										noIcon, noKey,	noMark, plain, nocommand;
/* [ 4] */	"9 Point",							noIcon,	noKey,	noMark,	plain,	cFontSizeBase+9;
/* [ 5] */	"10 Point",							noIcon,	noKey,	noMark,	plain,	cFontSizeBase+10;
/* [ 6] */	"12 Point",							noIcon,	noKey,	noMark,	plain,	cFontSizeBase+12;
/* [ 7] */	"14 Point",							noIcon,	noKey,	noMark,	plain,	cFontSizeBase+14;
/* [ 8] */	"18 Point",							noIcon,	noKey,	noMark,	plain,	cFontSizeBase+18;
/* [ 9] */	"24 Point",							noIcon,	noKey,	noMark,	plain,	cFontSizeBase+24;
/* [10] */	"-",										noIcon,	noKey,	noMark,	plain,	nocommand;
/* [11] */	"Larger",								noIcon,	"]",		noMark,	plain,	cLargerFontSize;
/* [12] */	"Smaller",							noIcon,	"[",		noMark,	plain,	cSmallerFontSize;
/* [13] */	"-",										noIcon,	noKey,	noMark,	plain,	nocommand;
/* [14] */	"Other",								noIcon,	noKey,	noMark,	plain,	cOtherFontSize;
/* [15] */	"-",										noIcon,	noKey,	noMark,	plain,	nocommand;
/* [16] */	"Font",									noIcon, kHierarchicalMenu, hmFontMenu, plain, cFont
	 }
	};

resource 'CMNU' (mControlMenu,
#if qNames
"Control",
#endif
nonpurgeable) {
	mControlMenu,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Control",
	 {
/* [ 1] */	"FailHere",							noIcon,	noKey,	noMark, plain, cFailHere;
/* [ 2] */	"Show All Files",				noIcon, noKey,	noMark, plain, cShowInvisibleFiles;
/* [ 3] */	"-",										noIcon, noKey,	noMark, plain, nocommand;
/* [ 4] */	"Expand All",						noIcon, noKey,	noMark, plain, cExpandAll;
/* [ 5] */	"Collapse All",					noIcon, noKey,	noMark, plain, cCollapseAll;
/* [ 6] */	"-",										noIcon, noKey,	noMark, plain, nocommand;
/* [ 7] */	"Send Apple Events",		noIcon,	noKey,	noMark, plain, cSendAppleEvents;
/* [ 8] */	"Send To Doc",					noIcon,	noKey,	noMark,	plain, cAppleEventRouting; //this is toggled
/* [ 9] */	"-",										noIcon, noKey,	noMark, plain, nocommand;
/* [10] */	"Allow Unlimited Docs",	noIcon,	noKey,	noMark, plain, cAllowUnlimitedDocs
	 }
	};


resource 'CMNU' (mWindowsMenu,
#if qNames
"Windows Menu",
#endif
nonpurgeable) {
	mWindowsMenu,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Windows",
	 {

	 }
	};


//I should probably append or otherwise incorporate the mTestMenu items in the MacApp
//provided Debug menu. I'll do that when I encounter a menu bar real estate problem.
#if qDebug					
resource 'CMNU' (mTestMenu,
#if qNames
"Test",
#endif
nonpurgeable) {
	mTestMenu,
	textMenuProc,
	EnablingManagedByMacApp,
	enabled,
	"Test",
	 {
/* [ 1] */	"AppUserFlag1",							noIcon,	noKey,	noMark, plain, cAppUserFlag1;
/* [ 2] */	"AppUserFlag2",							noIcon,	noKey,	noMark, plain, cAppUserFlag2;
/* [ 3] */	"AppUserFlag3",							noIcon,	noKey,	noMark, plain, cAppUserFlag3;
/* [ 4] */	"-",												noIcon, noKey,	noMark, plain, nocommand;
/* [ 5] */	"Count Objects",						noIcon,	noKey,	noMark, plain, cCountObjects;
/* [ 6] */	"Reset Object Count",				noIcon,	noKey,	noMark, plain, cResetObjectCount;
/* [ 7] */	"-",												noIcon, noKey,	noMark, plain, nocommand;
/* [ 8] */	"Print Base Class Info",		noIcon,	noKey,	noMark, plain, cPrintBaseClassInfo;
/* [ 9] */	"Print MacApp Class Info",	noIcon,	noKey,	noMark, plain, cPrintMacAppClassInfo;
/* [10] */	"Print App Class Info",			noIcon,	noKey,	noMark, plain, cPrintAppClassInfo

	};
};
#endif


resource 'CMNU' (mFontMenu,
#if qNames
"FontMenu",
#endif
nonpurgeable
) {
	mFontMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Fonts",
	{ }
};

//--------------------------------------------------------------------------------------------------
// Balloon Help Resources for Menus 
//--------------------------------------------------------------------------------------------------

include "Defaults.rsrc"  'hmnu' (mApple);	

//--------------------------------------------------------------------------------------------------
// RESOURCES FOR VIEWS, DIALOGS, ALERTS etc. 
//--------------------------------------------------------------------------------------------------


//--------------------------------------------------------------------------------------------------
// Views 
//--------------------------------------------------------------------------------------------------

resource 'STR#' (kTwistDownTitles,
#if qNames
"Window titles",
#endif
nonpurgeable) {
	{
/* [1] */	"",
/* [2] */	"Font Size Change",
/* [3] */	"Font Size:",
/* [4] */	"OK",
/* [5] */	"Cancel",
/* [6] */	"Stop",
/* [7] */	"Reading:",
/* [8] */	"Untitled",
	}
};

resource 'View' (kTwistDownWindowID, 
#if qNames
"TwistDownWindow",
#endif 
nonpurgeable) {MAThreeOh,
	{	/* array ViewArray: 5 elements */
		/* [1] */
		ViewSignatureAndClassname {
			'wind',600,"",noID,enabled,noIdle,{},MAThreeOh,
			{76,179},{238,239},sizeVariable,sizeVariable,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,noHelpID,1,
			NoDrawingEnvironment {},
			AdornerListSignatureAndClassname {
				NoIdentifier,AdornerList,AdornerElementSize,AdornerElementSizeShift,
				DynamicArrayAllocationIncrement,
				{
					AdornFirst,AdornerLocalObject {EraseAdorner},
					DrawView,AdornerLocalObject {DrawAdorner},
					AdornLast,AdornerLocalObject {ResizeIconAdorner}
				}
			},
			emptyUserArea,
			Window {
				zoomDocProc,kTwistDownViewID,goAwayBox,resizable,ignoreFirstClick,
				freeOnClosing,disposeOnFree,closesDocument,openWithDocument,
				dontAdaptToScreen,stagger,forceOnScreen,center,
				doesntFloat,doesntHideOnSuspend,generateActivates,filler,kTwistDownTitles,1
			},
			3
		},
		/* [2] */
		ViewSignatureAndClassname {
			'scrl',252,"",'SCLR',enabled,noIdle,{},MAThreeOh,
			{0,0},{223,224},sizeRelSuperView,sizeRelSuperView,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,noHelpID,1,
			NoDrawingEnvironment {},
			NoAdorners {},
			emptyUserArea,
			Scroller {
				'vCLR','hCLR',{501,502},{16,16},VertConstrain,HorzConstrain,
				{0,0,0,0},respondsToFKeys
			},
			1
		},
		/* [3] */
		ViewSignatureAndClassname {
			'lstg',141,"TTwistDownView",kTwistDownViewID,enabled,noIdle,{},MAThreeOh,
			{0,0},{223,224},sizeVariable,sizeVariable,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,noHelpID,1,
			NoDrawingEnvironment {},
			AdornerListSignatureAndClassname {
				NoIdentifier,AdornerList,AdornerElementSize,AdornerElementSizeShift,
				DynamicArrayAllocationIncrement,
				{
					DrawView,AdornerLocalObject {DrawAdorner},
					72,AdornerLocalObject {SelectionAdorner}
				}
			},
			emptyUserArea,
			TextListView {
				0,1,0,1000,2,2,dontAdornRows,dontAdornCols,singleSelection,kApplFont12TextStyle,dontPreferOutline
			},
			NoSubviews
		},
		/* [4] */
		ViewSignatureAndClassname {
			'ssbr',101,"",'hCLR',enabled,noIdle,{},MAThreeOh,
			{223,-1},{16,226},sizeVariable,sizeVariable,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,noHelpID,1,
			NoDrawingEnvironment {},
			NoAdorners {},
			emptyUserArea,
			ScrollerScrollBar {
				mHScrollBarHit,notHilited,notDimmed,sizeable,{0,0,0,0},
				kSystemFontTextStyle,dontPreferOutline,h,0,0,278
			},
			NoSubviews
		},
		/* [5] */
		ViewSignatureAndClassname {
			'ssbr',101,"",'vCLR',enabled,noIdle,{},MAThreeOh,
			{-1,224},{225,16},sizeVariable,sizeVariable,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,noHelpID,1,
			NoDrawingEnvironment {},
			NoAdorners {},
			emptyUserArea,
			ScrollerScrollBar {
				mVScrollBarHit,notHilited,notDimmed,sizeable,{0,0,0,0},
				kSystemFontTextStyle,dontPreferOutline,v,0,0,278
			},
			NoSubviews
		}
	}
};


resource 'View' (kChangeFontSizeWindowID, 
#if qNames
"ChangeFontSizeDialog", 
#endif 
nonpurgeable) {
	MAThreeOh,
	{	/* array ViewArray: 6 elements */
		/* [1] */
		ViewSignatureAndClassname {
			'wind',840,"",noID,enabled,noIdle,
			{
				BehaviorSignatureAndClassname {
					noID,"TDialogBehavior",DialogBehavior {enabled,noIdle,modal,kDefaultOKItemID,kCancelItemID}
				}
			},
			MAThreeOh,
			{239,223},{100,200},sizeVariable,sizeVariable,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,noHelpID,1,
			NoDrawingEnvironment {},
			AdornerListSignatureAndClassname {
				NoIdentifier,AdornerList,AdornerElementSize,AdornerElementSizeShift,
				DynamicArrayAllocationIncrement,
				{
					AdornFirst,AdornerLocalObject {EraseAdorner},
					DrawView,AdornerLocalObject {DrawAdorner}
				}
			},
			emptyUserArea,
			Window {
				movableDBoxProc,kChangeFontSizeViewID,noGoAwayBox,notResizable,ignoreFirstClick,
				freeOnClosing,disposeOnFree,doesntCloseDocument,dontOpenWithDocument,
				dontAdaptToScreen,dontStagger,forceOnScreen,center,doesntFloat,
				doesntHideOnSuspend,generateActivates,filler,kTwistDownTitles,2
			},
			1
		},
		/* [2] */
		ViewSignatureAndClassname {
			'view',669,"TChangeFontSizeDialog",kChangeFontSizeViewID,notEnabled,noIdle,{},MAThreeOh,
			{0,0},{100,200},sizeFixed,sizeFixed,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,noHelpID,1,
			NoDrawingEnvironment {},
			NoAdorners {},
			emptyUserArea,
			View {},
			4
		},
		/* [3] */
		ViewSignatureAndClassname {
			'stat',96,"",noID,notEnabled,noIdle,{},MAThreeOh,
			{17,9},{22,73},sizeFixed,sizeFixed,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,noHelpID,1,
			NoDrawingEnvironment {},
			NoAdorners {},
			emptyUserArea,
			StaticText {
				mStaticTextHit,notHilited,notDimmed,notSizeable,{0,0,0,0},
				kSystemFontTextStyle,dontPreferOutline,autoWrap,dontEraseFirst,justSystem,kTwistDownTitles,3
			},
			NoSubviews
		},
		/* [4] */
		ViewSignatureAndClassname {
			'butn',203,"",kDefaultOKItemID,enabled,noIdle,{},MAThreeOh,
			{51,97},{28,72},sizeFixed,sizeFixed,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,kChangeFontSizeDialogHelp,2,
			DrawingEnvironmentClassIDAndClassname {
				1,"TDrawingEnvironment",{3,3},8,$"FFFF FFFF FFFF FFFF",{0,0,0},{65535,65535,65535}
			},
			AdornerListSignatureAndClassname {
				NoIdentifier,AdornerList,AdornerElementSize,
				AdornerElementSizeShift,
				DynamicArrayAllocationIncrement,
				{
					DrawView,AdornerLocalObject {DrawAdorner},
					AdornAfter,AdornerSignatureAndClassname {'rrct',"",'outl',freeOnDeletion,$""}
				}
			},
			emptyUserArea,
			Button {
				mDismiss,notHilited,notDimmed,notSizeable,{4,4,4,4},
				kSystemFontTextStyle,dontPreferOutline,kTwistDownTitles,4
			},
			NoSubviews
		},
		/* [5] */
		ViewSignatureAndClassname {
			'butn',92,"",kCancelItemID,enabled,noIdle,{},MAThreeOh,
			{55,9},{20,64},sizeFixed,sizeFixed,shown,doesntWantToBeTarget,
			handlesCursor,letsSubViewsHandleCursor,noCursorID,
			handlesHelp,letsSubViewsHandleHelp,kChangeFontSizeDialogHelp,3,
			NoDrawingEnvironment {},
			NoAdorners {},
			emptyUserArea,
			Button {
				mDismiss,notHilited,notDimmed,notSizeable,{0,0,0,0},
				kSystemFontTextStyle,dontPreferOutline,kTwistDownTitles,5
			},
			NoSubviews
		},
		/* [6] */
		ViewSignatureAndClassname {
			'nmbr',171,"",kSizeValueViewID,enabled,noIdle,{},MAThreeOh,
			{17,97},{22,36},sizeFixed,sizeFixed,shown,wantsToBeTarget,
			handlesCursor,doesntLetSubViewsHandleCursor,1,
			handlesHelp,letsSubViewsHandleHelp,kChangeFontSizeDialogHelp,1,
			NoDrawingEnvironment {},
			AdornerListSignatureAndClassname {
				NoIdentifier,AdornerList,AdornerElementSize,AdornerElementSizeShift,
				DynamicArrayAllocationIncrement,
				{
					DrawView,AdornerLocalObject {DrawAdorner},
					AdornAfter,AdornerSignatureAndClassname {'fram',"",NoIdentifier,freeOnDeletion,$""}
				}
			},
			emptyUserArea,
			NumberText {
				mEditTextHit,notHilited,notDimmed,notSizeable,{3,3,3,3},
				kSystemFontTextStyle,dontPreferOutline,autoWrap,dontEraseFirst,
				justSystem,-1,-1,4,LeftRightUpDownBackspace,0,9,48
			},
			NoSubviews
		}
	}
};



//--------------------------------------------------------------------------------------------------
// MultiFinder information
//--------------------------------------------------------------------------------------------------

#if qNames
#define kNamesSizeDelta 75
#else
#define kNamesSizeDelta 0
#endif

#if qDebug
#define kDebugSizeDelta 250
#else
#define kDebugSizeDelta 0
#endif

#if qModelFarCode
#define kModelFarSizeDelta 0
#else
#define kModelFarSizeDelta 0
#endif


resource 'SIZE' (-1) {
	saveScreen,
	acceptSuspendResumeEvents,
	enableOptionSwitch,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreAppDiedEvents,
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	notStationeryAware,				
	reserved,
	reserved,
	reserved,
	reserved,
	
	/* Suggested partition size */
	(1700 + kNamesSizeDelta + kDebugSizeDelta + kModelFarSizeDelta) * 1024,
	
	/* Minimum partition size */
	(1200 + kNamesSizeDelta + kDebugSizeDelta + kModelFarSizeDelta) * 1024
};

//--------------------------------------------------------------------------------------------------
// Memory usage information for Twist Down Lists
//--------------------------------------------------------------------------------------------------

// See Memory.r
resource 'mem!' (132,
#if qNames
	kApplicationName,
#endif
	purgeable) {
	0,		// Add to object heap size
	2*1024,		// Add to heap increment size
	26*1024,		// Add to temporary reserve
	36*1024,		// Add to permanent reserve
	32 *1024		// Add to stack space
};

#if !qPowerPC
resource 'seg!' (kTwistDownAppSeg,
#if qNames
kApplicationName,
#endif
	purgeable) {
	{
		"ARes";		
		"ProgBarOpen";
		"ProgBarClose";
		"ProgBarRes";
		"GFinder";
		"GInit";
		"GOpen2";
		"GNonRes2";
		"GNonRes3";
		"GClipboard";		
		"GReadFile";
		"GTerminate";		
		"GWriteFile";
		"GSelCommand";
		
	}
};
#endif qPowerPC

// Additional Resident Segments
// ----------------------------
/*
resource 'res!' (kTwistDownAppRes,
#if qNames
	kApplicationName,
#endif
	purgeable) {
	{	
		"ARes";		
		"ProgBarOpen";
		"ProgBarClose";
		"ProgBarRes";
		"GFinder";
		"GInit";
		"GOpen2";
		"GNonRes2";
		"GNonRes3";
		"GClipboard";		
		"GReadFile";
		"GTerminate";		
		"GWriteFile";		
		"GSelCommand";
		
	};
};


*/
// Code fragment resource for PowerPC native apps
// ----------------------------------------------
#if qPowerPC
#include "CodeFragmentTypes.r"

resource 'cfrg' (0, "Configuration Info") {
	{
		kPowerPC,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		0,
		0,
		kIsApp,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"Twist Down Lists"
	}
};
#endif

//--------------------------------------------------------------------------------------------------
// Icons, Bundles and FRefs
//--------------------------------------------------------------------------------------------------

type kSignature as 'STR ';
resource kSignature (0,
#if qNames
"Signature",
#endif
	purgeable) {
	TDL_LONG_VERSION
};

resource 'FREF' (kApplicationID,
#if qNames
"Twist Down Lists Application",
#endif
	purgeable) {
	'APPL',
	0,
	""
};

resource 'FREF' (kDocumentID,
#if qNames
"Twist Down Lists Document",
#endif
	purgeable) {
	kFileType,
	1,
	""
};

resource 'BNDL' (kBundleID,
#if qNames
"Twist Down Lists",
#endif
	purgeable) {
	kSignature,
	0,
	{ /* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{ /* array IDArray: 2 elements */
			0, kApplicationID
//			1, kDocumentID
		},
		/* [2] */
		'FREF',
		{ /* array IDArray: 2 elements */
			0, kApplicationID,
			1, kDocumentID
		}
	}
};

//--------------------------------------------------------------------------------------------------
//  Version resources
//--------------------------------------------------------------------------------------------------

// The revision of this particular file

resource 'vers' (1,
#if qNames
"File Version",
#endif
	purgeable) {
	TDL_VERS_CODE,
	verUs,
	TDL_SHORT_VERSION,
	TDL_LONG_VERSION
};

#if !qPowerPC
resource 'vers' (2,
#if qNames
	"Package Version",
#endif
	purgeable) {
	TDL_VERS_CODE,
	verUs,
	TDL_SHORT_VERSION,
	TDL_LONG_VERSION
};
#endif

#ifndef __TDLAETERMINOLOGYEXTENSION__
#include "TDL_AETerminologyExtension.r"
#endif

#ifndef __TWISTDOWNLISTICONS__
#include "TwistDownListIcons.r"
#endif

#ifndef __TDLABOUTBOX__
#include "TDLAboutBox.r"
#endif